	PROGRAM RESEQ
C
C	COPYRIGHT (C) 1979,1980
C		MANAGEMENT SCIENCE ASSOCIATES, INC.
C		5100 CENTRE AVENUE
C		PITTSBURGH, PENNSYLVANIA  15232
C
C	THIS SOFTWARE IS DISTRIBUTED WITHOUT COST, AND MAY BE
C	REPRODUCED ONLY WITH THE INCLUSION OF THIS COPYRIGHT
C	STATEMENT.  MANAGEMENT SCIENCE ASSOCIATES ASSUMES NO
C	RESPONSIBILITY FOR THE PERFORMANCE OF THIS SOFTWARE.
C
C	AUTHOR:	MARK PILANT
C
C	MODIFIED: GERSON H COHEN
C		  NIH, BLDG 2, ROOM 312,
C		  BETHESDA, MD  20205
C
C THIS PROGRAM TAKES A FORTRAN PROGRAM AND RESEQUENCES IT.
C IT ASSUMES THAT THE PROGRAM HAS NO UNDEFINED STATEMENTS, AND IS
C SYNTACTICALLY CORRECT.
C
C THE FOLLOWING LIMITATIONS CURRENTLY (2/83) EXIST:
C
C   1.	THE PROGRAM MUST NOT HAVE SEQUENCE NUMBERS IS COLS. 73-80
C
C   2.	A STATEMENT LABEL REFERENCE MUST NOT BE SPLIT ACROSS LINES; I.E.,
C
C		GOTO 10
C		1 10
C
C   3.	RESEQ MAY GET CONFUSED IF THE LINE IS A READ/WRITE STATEMENT
C	USING DIRECT ACCESS FORMAT; I.E.,
C
C		READ(UNIT'RECORD,FORMAT)LIST
C
C	AT THE LEAST, THE FORMAT STATEMENT LABEL WILL NOT BE PROPERLY RESET
C
	IMPLICIT INTEGER (A-Z)
C
C I/O UNITS
C
	PARAMETER INP=-3
	PARAMETER OUT=-2
C
C CHARACTER VALUES
C
	PARAMETER IGNORE=1
	PARAMETER ALPHA =2
	PARAMETER NUMBER=3
	PARAMETER SPCIAL=4
	PARAMETER CPYORG=5
	PARAMETER TAB=CHAR(9)
C
C STORAGE
C
	CHARACTER LINE*6600,IFILE*100,STMTC(14)*6,FMT*4,CLAB*5,CHRIDX*1,
     1		  ORGLIN*100,NEWLIN*100,SWITCH(6)*10,OFILE*100,LYNE*6600
	DIMENSION LABEL(10000,2),SWTCHV(6)
	BYTE CHRTBL(0:127),BYTIDX,LBLFLG(10000)
	LOGICAL QUOTE
	EQUIVALENCE (CHRIDX,BYTIDX),(SWTCHV(1),FMTBEG),
     1		    (SWTCHV(2),INCRMT),(SWTCHV(4),LINBEG),
     2		    (SWTCHV(5),LSTFLG),(SWTCHV(6),SYMFLG)
	COMMON/FLAGS/ GOTLIN(2),LINFLG,SWTCHV
	COMMON/UNITS/ FIL1,FIL2,FIL3,FIL4,FIL5
	COMMON LINENO
C
C TABLE FOR STATEMENT KEYWORD SEARCH
C
	DATA STMTC /'ACCEPT','ASSIGN','CALL',  'CLOSE', 'DECODE',
     1              'DO',    'ENCODE','GOTO',  'IF',    'OPEN',
     2              'PRINT', 'READ',  'TYPE',  'WRITE'/
C
C LEGAL SWITCH NAMES
C
	DATA SWITCH(1) /'FORMAT'/,
     1	     SWITCH(2) /'INCREMENT'/,
     2	     SWITCH(3) /'RIGHT'/,
     3	     SWITCH(4) /'STATEMENT'/,
     4	     SWITCH(5) /'LIST'/,
     5	     SWITCH(6) /'SYMBOLS'/
C
C CHARACTER VALUE TABLE
C
	DATA CHRTBL/
     1	     IGNORE,IGNORE,IGNORE,IGNORE,IGNORE,IGNORE,IGNORE,IGNORE,	!0-7
     2	     IGNORE,CPYORG,IGNORE,IGNORE,IGNORE,IGNORE,IGNORE,IGNORE,	!10-17
     3	     IGNORE,IGNORE,IGNORE,IGNORE,IGNORE,IGNORE,IGNORE,IGNORE,	!20-27
     4	     IGNORE,IGNORE,IGNORE,IGNORE,IGNORE,IGNORE,IGNORE,IGNORE,	!30-37
     5	     CPYORG,SPCIAL,SPCIAL,SPCIAL,SPCIAL,SPCIAL,SPCIAL,SPCIAL,	!40-47
     6	     SPCIAL,SPCIAL,SPCIAL,SPCIAL,SPCIAL,SPCIAL,SPCIAL,SPCIAL,	!50-57
     7	     NUMBER,NUMBER,NUMBER,NUMBER,NUMBER,NUMBER,NUMBER,NUMBER,	!60-67
     8	     NUMBER,NUMBER,SPCIAL,SPCIAL,SPCIAL,SPCIAL,SPCIAL,SPCIAL,	!70-77
     9	     SPCIAL,ALPHA ,ALPHA ,ALPHA ,ALPHA ,ALPHA ,ALPHA ,ALPHA ,	!100-107
     A	     ALPHA ,ALPHA ,ALPHA ,ALPHA ,ALPHA ,ALPHA ,ALPHA ,ALPHA ,	!110-117
     B	     ALPHA ,ALPHA ,ALPHA ,ALPHA ,ALPHA ,ALPHA ,ALPHA ,ALPHA ,	!120-127
     C	     ALPHA ,ALPHA ,ALPHA ,SPCIAL,SPCIAL,SPCIAL,SPCIAL,SPCIAL,	!130-137
     D	     SPCIAL,ALPHA ,ALPHA ,ALPHA ,ALPHA ,ALPHA ,ALPHA ,ALPHA ,	!140-147
     E	     ALPHA ,ALPHA ,ALPHA ,ALPHA ,ALPHA ,ALPHA ,ALPHA ,ALPHA ,	!150-157
     F	     ALPHA ,ALPHA ,ALPHA ,ALPHA ,ALPHA ,ALPHA ,ALPHA ,ALPHA ,	!160-167
     G	     ALPHA ,ALPHA ,ALPHA ,SPCIAL,SPCIAL,SPCIAL,SPCIAL,IGNORE/	!170-177
	FIL1=10		!PASS 1 INPUT FILE
	FIL2=11		!PASS 2 INPUT FILE
	FIL3=12		!FILE TO COMPARE LINES WITH
	FIL4=13		!OUTPUT FILE (RESEQUENCED)
	FIL5=14		!LISTING OR SYMBOL TABLE FILE
C
C INITIALIZE VARIABLES
C
10	NUMLAB=0			!NUMBER OF LABELS
	LINBEG=10			!BEGINNING LINE NUMBER
	FMTBEG=0			!BEGINNING FORMAT LINE NUMBER
	INCRMT=10			!INCREMENT FOR LINE NUMBERS
	RJUST=0				!IF 1, RIGHT JUSTIFY LABEL
	LSTFLG=0			!NO LISTING
	SYMFLG=0			!NO SYMBOL TABLE
	SWTCHV(3)=0
	GOTLIN(1)=0			!NO LINE IF STORAGE
	GOTLIN(2)=0			!SAME HERE
	OFILE='TT:'
	OFILEN=3
	LINENO=0
D	TYPE *,'DEBUG VALUE'
D	ACCEPT *,DEBCOD
C
C GET NAME OF FILE TO RESEQUENCE
C
	WRITE(OUT,10000)
10000	FORMAT(' * '$)
	READ(INP,10010,END=590)LINLEN,LINE
10010	FORMAT(Q,A)
	IF(LINLEN.EQ.0.OR.LINE.EQ.' ') GOTO 10
	LINE=LINE(1:LINLEN)//'/'
	LINLEN=LINLEN+1
	STS = STR$UPCASE(LINE(:LINLEN),LINE(:LINLEN))
	START=1
	PTR=1
	SWI=0
	SWIVAL=0
	IFILEN=0
20	IF(SWI.EQ.1.AND.(LINE(PTR:PTR).EQ.'/'.OR.LINE(PTR:PTR).EQ.'='))
     1	    THEN
	    PRMLEN=PTR-START
	    IF(SWIVAL.NE.0) THEN
		STS=VALUE(LINE(START:PTR-1),TMP)
		IF(.NOT.STS) THEN
		    IF(LINE(PTR:PTR).EQ.'=') THEN
			TYPE 10020,LINE(START:PTR-1)
10020			FORMAT(' Illegal switch value: ',A)
			GOTO 10
			ENDIF
		    OFILEN=IFILEN
		    OFILE(1:OFILEN)=IFILE(1:IFILEN)
		    IFILEN=PRMLEN
		    IFILE(1:IFILEN)=LINE(START:PTR-1)
		    SWIVAL=0
		    START=PTR+1
		    GOTO 40
		ENDIF
		IF(TMP.GT.99999) THEN
		    TYPE 10030,TMP
10030		    FORMAT(' Illegal switch value: ',I10)
		    GOTO 10
		ENDIF
		SWTCHV(SWINDX)=TMP
		SWIVAL=0
		IF(LINE(PTR:PTR).EQ.'=') SWI=0
		START=PTR+1
		GOTO 40
	    ENDIF
	    IF(LINE(PTR:PTR).EQ.'=') THEN
		SWIVAL=1
	    ENDIF
	    SWINDX=0
	    DO 30 I=1,6
	    IF(LINE(START:PTR-1).EQ.SWITCH(I)(1:PRMLEN)) SWINDX=I
30	    CONTINUE
	    IF(SWINDX.EQ.0) THEN
		TYPE 10040,LINE(START:PTR-1)
10040		FORMAT(' Illegal switch: ',A)
		GOTO 10
	    ENDIF
	    IF(SWIVAL.EQ.0) SWTCHV(SWINDX)=-1
	    START=PTR+1
	    GOTO 40
	ENDIF
	IF(SWI.EQ.0.AND.(LINE(PTR:PTR).EQ.'/'.OR.LINE(PTR:PTR).EQ.'='))
     1	    THEN
	    IF(LINE(PTR:PTR).EQ.'=') THEN
		IF(START.EQ.PTR) THEN
		    OFILE='NL:'
		ELSE
		    OFILEN=PTR-START
		    OFILE(1:OFILEN)=LINE(START:PTR-1)
	    ENDIF
		START=PTR+1
		GOTO 40
	    ENDIF
	    IF(LINE(PTR:PTR).EQ.'/') SWI=1
	    IFILEN=PTR-START
	    IF(IFILEN.EQ.0) THEN
		TYPE 10050
10050		FORMAT(' File specification must preceed any switches')
		GOTO 10
	    ENDIF
	    IFILE(1:IFILEN)=LINE(START:PTR-1)
	    START=PTR+1
	ENDIF
40	PTR=PTR+1
	IF(PTR.LE.LINLEN) GOTO 20
	IF(SWTCHV(3).EQ.-1) RJUST=1
C
C OPEN THE SPECIFIED FILE
C
	OPEN(UNIT=FIL1,NAME=IFILE(1:IFILEN),TYPE='OLD',READONLY,ERR=560)
	OPEN(UNIT=FIL2,NAME=IFILE(1:IFILEN),TYPE='OLD',READONLY)
	OPEN(UNIT=FIL3,NAME=IFILE(1:IFILEN),TYPE='OLD',READONLY)
	OPEN(UNIT=FIL4,NAME=OFILE(1:OFILEN),TYPE='NEW',
     1	     CARRIAGECONTROL='LIST',ERR=570)
	IF(LSTFLG.NE.0.OR.SYMFLG.NE.0) OPEN(UNIT=FIL5,NAME='NEWFILE.LIS',
     1			     TYPE='NEW',CARRIAGECONTROL='FORTRAN')
C
C				P A S S   1
C
C SCAN ALL LINES UNTIL END STATEMENT FOR LABELS BUILD SYMBOL TABLE
C
50	STS=GETLIN(FIL1,LINE,LINLEN)
	IF(STS.LT.0) GOTO 550
	IF(.NOT.STS) STOP 'Error reading input file'
	STS = STR$UPCASE(LINE(:LINLEN),LINE(:LINLEN))
	IF(LINE(1:1).EQ.'C'.OR.LINE(1:1).EQ.'*') GOTO 50
	IF(LINE(1:1).EQ.'D') LINE(1:1)=' '
	IF(LINE(7:LINLEN).EQ.'END') GOTO 70
C
C SEE IF LINE HAS LABEL
C
	IF(LINLEN.LT.9) GOTO 50
	IF(LINE(1:5).EQ.'     ') GOTO 50
	NUMLAB=NUMLAB+1
	STS=VALUE(LINE(1:5),LABEL(NUMLAB,1))
	IF(.NOT.STS) TYPE 10060,LINE(1:LINLEN)
10060	FORMAT(' Illegal label field in line: ',A)
	LBLFLG(NUMLAB)=0
	IF(LINE(7:12).NE.'FORMAT') GOTO 50
	PARCNT=0
	PTR=13
60	IF(LINE(PTR:PTR).EQ.'='.AND.PARCNT.EQ.0) GOTO 50
	IF(LINE(PTR:PTR).EQ.'(') PARCNT=PARCNT+1
	IF(LINE(PTR:PTR).EQ.')') PARCNT=PARCNT-1
	PTR=PTR+1
	IF(PTR.LE.LINLEN) GOTO 60
	LBLFLG(NUMLAB)=1
	GOTO 50
C
C TAG ON NEW LABEL
C
70	IF(NUMLAB.EQ.0) GOTO 100
	TMPL=LINBEG
	TMPF=FMTBEG
	DO 80 I=1,NUMLAB
	IF(LBLFLG(I).EQ.0.OR.FMTBEG.EQ.0) THEN
	    LABEL(I,2)=TMPL
	    TMPL=TMPL+INCRMT
	    ENDIF
	IF(LBLFLG(I).EQ.1.AND.FMTBEG.NE.0) THEN
	    LABEL(I,2)=TMPF
	    TMPF=TMPF+INCRMT
	    ENDIF
80	CONTINUE
C
C SORT LABELS INTO ASCENDING ORDER
C
	IF(NUMLAB.EQ.1) GOTO 100
	DO 90 I=1,NUMLAB-1
	DO 90 J=I+1,NUMLAB
	IF(LABEL(I,1).LT.LABEL(J,1)) GOTO 90
	TMP1=LABEL(I,1)
	TMP2=LABEL(I,2)
	LABEL(I,1)=LABEL(J,1)
	LABEL(I,2)=LABEL(J,2)
	LABEL(J,1)=TMP1
	LABEL(J,2)=TMP2
90	CONTINUE
C
C			E N D   O F   P A S S   1
C
C PRINT OUT SYMBOL TABLE
C
100	IF(SYMFLG.NE.0.AND.NUMLAB.GT.0)
     1		CALL COLPRI(FIL5,NUMLAB,LABEL(1,1))
C
C				P A S S   2
C
C GET A LINE, DETERMINE IF IT CONTAINS A KEYWORD, AND SUBSTITUTE NEW
C LABELS FOR OLD IF ANY
C
C GET A LINE
C
110	STS=GETLIN(FIL2,LINE,LINLEN)
D	IF(DEBCOD.EQ.3) THEN
D	    TMP=LINLEN
D	    IF(TMP.GT.72) TMP=72
D	    TYPE *,TMP,LINE(1:TMP)
D	    ENDIF
	IF(STS.LT.0) GOTO 550
	IF(.NOT.STS) STOP 'Error reading input file'
	STS = STR$UPCASE(LYNE(1:LINLEN),LINE(1:LINLEN))
	IF(LYNE(1:1).EQ.'C'.OR.LYNE(1:1).EQ.'*') GOTO 430
	IF(LYNE(1:1).EQ.'D') LINE(1:1)=' '
	IF(LYNE(7:LINLEN).EQ.'END') GOTO 540
	LINENO=LINENO+1
C
C SEE IF LINE HAS LABEL
C
	IF(LINE(1:5).EQ.'     ') GOTO 120
	STS=VALUE(LINE(1:5),LINLAB)
	IF(.NOT.STS) GOTO 430
C
C SUBSTITUTE NEW LABEL FOR OLD LABEL
C
	INDX=BSRCH(LABEL(1,1),NUMLAB,LINLAB)
	IF(INDX.EQ.0) GOTO 580
	LINLAB=LABEL(INDX,2)
	LABLEN=IFIX(ALOG10(FLOAT(LINLAB))+1)
	IF(RJUST.NE.0) LABLEN=5
	LINE(1:5)='     '
	WRITE (LINE(1:5),'(I<LABLEN>)')LINLAB
C
C SCAN LINE FOR KEYWORD
C
120	COL=7
	START=1
	END=14
130	DO I=START,END
		CALL STR$TRIM(STMTC(I),STMTC(I),LCOL)
		MCOL = LCOL + COL - 1
		IF (LYNE(COL:MCOL).EQ.STMTC(I)(1:LCOL)) THEN
			INDX = I
			COL = MCOL + 1
			GO TO 150
		END IF
	END DO
	GOTO 430	! KEYWORD NOT FOUND
C
C LINE MAY CONTAIN KEYWORD. DISPATCH TO APPROPRIATE ROUTINE FOR FURTHER
C CHECKING. IN ADDITION, IF THE LINE CONTAINS LABELS, SUBSTITUTE NEW ONE
C FOR OLD ONE.
C
C DISPATCH ON KEYWORD INDEX
C
150	GOTO (160,180,190,210,230,270,230,320,360,210,160,380,160,380),
     1	     INDX
	STOP 'Internal error'
C
C TYPE 1 - ACCEPT STATEMENT, TYPE 11 - PRINT STATEMENT,
C TYPE 13 - TYPE STATEMENT
C
160	IF(LINE(COL:COL+1).EQ.'*,') GOTO 430
	IF(LINE(COL:COL).LT.'0'.OR.LINE(COL:COL).GT.'9') GO TO 430
	END=INDEX(LINE(COL:LINLEN),',')
	IF (END.EQ.0) THEN
	    END=LINLEN
	ELSE
	    END=COL+END-2
	END IF
	STS=VALUE(LINE(COL:END),STMT)
	IF(.NOT.STS) GOTO 430
	INDX=BSRCH(LABEL(1,1),NUMLAB,STMT)
	IF(INDX.EQ.0) GOTO 580
	STS=CVTNUM(LABEL(INDX,2),CLAB,CLEN)
	LINE=LINE(1:COL-1)//CLAB(1:CLEN)//LINE(END+1:LINLEN)
	LINLEN=COL+CLEN+LINLEN-END-1
	GOTO 430
C
C TYPE 2 - ASSIGN STATEMENT
C
180	IF(INDEX(LINE(COL:LINLEN),'=').NE.0) GOTO 430
	IF(LINE(COL:COL).LT.'0'.OR.LINE(COL:COL).GT.'9') GOTO 430
	LOCTO=INDEX(LINE(COL:LINLEN),'TO')
	IF(LOCTO.EQ.0) GOTO 430
	END=LOCTO+COL-2
	STS=VALUE(LINE(COL:END),STMT)
	IF(.NOT.STS) GOTO 430
	INDX=BSRCH(LABEL(1,1),NUMLAB,STMT)
	IF(INDX.EQ.0) GOTO 580
	STS=CVTNUM(LABEL(INDX,2),CLAB,CLEN)
	LINE=LINE(1:COL-1)//CLAB(1:CLEN)//LINE(END+1:LINLEN)
	LINLEN=COL+CLEN+LINLEN-END-1
	GOTO 430
C
C TYPE 3 - CALL STATEMENT
C
190	IF(INDEX(LINE(COL:LINLEN),'=').NE.0) GOTO 430
	IF(INDEX(LINE(COL:LINLEN),'(').EQ.0) GOTO 430
200	LOCAST=INDEX(LINE(COL:LINLEN),'*')
	LOCAMP=INDEX(LINE(COL:LINLEN),'&')
	IF(LOCAST.EQ.0.AND.LOCAMP.EQ.0) GOTO 430
	IF(LOCAST.EQ.0) LOCAST=99999
	IF(LOCAMP.EQ.0) LOCAMP=99999
	IF(LOCAST.LT.LOCAMP) THEN
	    COL=LOCAST+COL
	    ELSE
	    COL=LOCAMP+COL
	    ENDIF
	LOCOMA=INDEX(LINE(COL:LINLEN),',')
	LOCRPR=INDEX(LINE(COL:LINLEN),')')
	IF(LOCOMA.LT.LOCRPR) END=LOCOMA+COL-2
	IF(LOCOMA.EQ.0) END=LOCRPR+COL-2
	STS=VALUE(LINE(COL:END),STMT)
	IF(.NOT.STS) GOTO 430
	INDX=BSRCH(LABEL(1,1),NUMLAB,STMT)
	IF(INDX.EQ.0) GOTO 580
	STS=CVTNUM(LABEL(INDX,2),CLAB,CLEN)
	LINE=LINE(1:COL-1)//CLAB(1:CLEN)//LINE(END+1:LINLEN)
	LINLEN=COL+CLEN+LINLEN-END-1
	COL=COL+CLEN
	GOTO 200
C
C TYPE 4 - CLOSE STATEMENT, TYPE 10 - OPEN STATEMENT
C
210	IF(LINE(COL:COL).NE.'(') GOTO 430
	END=COL
	PARCNT=0
220	IF(LINE(END:END).EQ.'=') THEN
	    IF(PARCNT.EQ.0) GOTO 430
	    IF(LYNE(END-4:END).NE.',ERR=') THEN
		END=END+1
		IF(END.LT.LINLEN) GOTO 220
		GOTO 430
		ENDIF
	    COL=END+1
	    ELSE
	    IF(LINE(END:END).EQ.'(') PARCNT=PARCNT+1
	    IF(LINE(END:END).EQ.')') PARCNT=PARCNT+1
	    END=END+1
	    IF(END.LE.LINLEN) GOTO 220
	    GOTO 430
	    ENDIF
	LOCOMA=INDEX(LINE(COL:LINLEN),',')
	LOCRPR=INDEX(LINE(COL:LINLEN),')')
	IF(LOCOMA.LT.LOCRPR) END=LOCOMA+COL-2
	IF(LOCOMA.EQ.0) END=LOCRPR+COL-2
	STS=VALUE(LINE(COL:END),STMT)
	IF(.NOT.STS) GOTO 430
	INDX=BSRCH(LABEL(1,1),NUMLAB,STMT)
	IF(INDX.EQ.0) GOTO 580
	STS=CVTNUM(LABEL(INDX,2),CLAB,CLEN)
	LINE=LINE(1:COL-1)//CLAB(1:CLEN)//LINE(END+1:LINLEN)
	LINLEN=COL+CLEN+LINLEN-END-1
	GOTO 430
C
C TYPE 5 - DECODE STATEMENT, TYPE 7 ENCODE STATEMENT
C
230	IF(LINE(COL:COL).NE.'(') GOTO 430
	OLDCOL=COL
	COL=COL+1
	PARCNT=1
240	IF(LINE(COL:COL).EQ.'(') PARCNT=PARCNT+1
	IF(LINE(COL:COL).EQ.')') PARCNT=PARCNT-1
	COL=COL+1
	IF(PARCNT.NE.0) GOTO 240
	IF(LINE(COL:COL).EQ.'=') GOTO 430
	COL=OLDCOL+1
	PARCNT=0
250	IF(LINE(COL:COL).EQ.','.AND.PARCNT.EQ.0) THEN
	    COL=COL+1
	    ELSE
	    IF(LINE(COL:COL).EQ.'(') PARCNT=PARCNT+1
	    IF(LINE(COL:COL).EQ.')') PARCNT=PARCNT-1
	    COL=COL+1
	    GOTO 250
	    ENDIF
	IF(LINE(COL:COL).LT.'0'.OR.LINE(COL:COL).GT.'9') GOTO 260
	END=INDEX(LINE(COL:LINLEN),',')+COL-2
	STS=VALUE(LINE(COL:END),STMT)
	IF(.NOT.STS) GOTO 430
	INDX=BSRCH(LABEL(1,1),NUMLAB,STMT)
	IF(INDX.EQ.0) GOTO 580
	STS=CVTNUM(LABEL(INDX,2),CLAB,CLEN)
	LINE=LINE(1:COL-1)//CLAB(1:CLEN)//LINE(END+1:LINLEN)
	LINLEN=COL+CLEN+LINLEN-END-1
260	COL=OLDCOL
	CALL STR$UPCASE(LYNE(1:LINLEN),LINE(1:LINLEN))
	LOCERR=INDEX(LYNE(COL:LINLEN),'ERR=')
	IF(LOCERR.EQ.0) GOTO 430
	COL=LOCERR+COL+3
	LOCRPR=INDEX(LINE(COL:LINLEN),')')
	END=LOCRPR+COL-2
	STS=VALUE(LINE(COL:END),STMT)
	IF(.NOT.STS) GOTO 430
	INDX=BSRCH(LABEL(1,1),NUMLAB,STMT)
	IF(INDX.EQ.0) GOTO 580
	STS=CVTNUM(LABEL(INDX,2),CLAB,CLEN)
	LINE=LINE(1:COL-1)//CLAB(1:CLEN)//LINE(END+1:LINLEN)
	LINLEN=COL+CLEN+LINLEN-END-1
	GOTO 430
C
C TYPE 6 - DO STATEMENT
C
270	IF(LINE(COL:COL).LT.'0'.OR.LINE(COL:COL).GT.'9') GOTO 430
	IF(INDEX(LINE(COL:LINLEN),'=').EQ.0) GOTO 430
	END=COL+1
280	IF(LINE(END:END).LT.'0'.OR.LINE(END:END).GT.'9') GOTO 290
	END=END+1
	GOTO 280
290	END=END-1
	STS=VALUE(LINE(COL:END),STMT)
	IF(.NOT.STS) GOTO 430
	CHRPOS=INDEX(LINE(COL:LINLEN),'=')+COL
	PARCNT=0
300	IF(LINE(CHRPOS:CHRPOS).EQ.',') THEN
	    IF(PARCNT.NE.0) GOTO 430
	    GOTO 310
	    ENDIF
	IF(LINE(CHRPOS:CHRPOS).EQ.'(') PARCNT=PARCNT+1
	IF(LINE(CHRPOS:CHRPOS).EQ.')') PARCNT=PARCNT-1
	CHRPOS=CHRPOS+1
	IF(CHRPOS.GT.LINLEN) GOTO 430
	GOTO 300
310	STS=VALUE(LINE(COL:END),STMT)
	IF(.NOT.STS) GOTO 430
	INDX=BSRCH(LABEL(1,1),NUMLAB,STMT)
	IF(INDX.EQ.0) GOTO 580
	STS=CVTNUM(LABEL(INDX,2),CLAB,CLEN)
	LINE=LINE(1:COL-1)//CLAB(1:CLEN)//LINE(END+1:LINLEN)
	LINLEN=COL+CLEN+LINLEN-END-1
	GOTO 430
C
C TYPE 8 - GOTO STATEMENT
C
320	IF(INDEX(LINE(COL:LINLEN),'=').NE.0) GOTO 430
	IF(LINE(COL:COL).LT.'0'.OR.LINE(COL:COL).GT.'9') GOTO 330
	STS=VALUE(LINE(COL:LINLEN),STMT)
	IF(.NOT.STS) GOTO 430
	INDX=BSRCH(LABEL(1,1),NUMLAB,STMT)
	IF(INDX.EQ.0) GOTO 580
	STS=CVTNUM(LABEL(INDX,2),CLAB,CLEN)
	LINE=LINE(1:COL-1)//CLAB(1:CLEN)
	LINLEN=COL+CLEN-1
	GOTO 430
330	IF(INDEX(LINE(COL:LINLEN),'(').EQ.0) GOTO 430
	IF(LINE(COL:COL).NE.'(') THEN
	    COL=INDEX(LINE(COL:LINLEN),'(')+COL
	    ELSE
	    COL=COL+1
	    ENDIF
	ENDFLG=0
	END=COL
340	IF(LINE(END:END).EQ.')') THEN
	    ENDFLG=1
	    END=END-1
	    GOTO 350
	    ENDIF
	IF(LINE(END:END).EQ.',') THEN
	    END=END-1
	    GOTO 350
	    ENDIF
	END=END+1
	GOTO 340
350	STS=VALUE(LINE(COL:END),STMT)
	IF(.NOT.STS) GOTO 430
	INDX=BSRCH(LABEL(1,1),NUMLAB,STMT)
	IF(INDX.EQ.0) GOTO 580
	STS=CVTNUM(LABEL(INDX,2),CLAB,CLEN)
	LINE=LINE(1:COL-1)//CLAB(1:CLEN)//LINE(END+1:LINLEN)
	LINLEN=COL+CLEN+LINLEN-END-1
	COL=COL+CLEN+1
	END=COL
	IF(ENDFLG.EQ.0) GOTO 340
	GOTO 430
C
C TYPE 9 - IF STATEMENT
C
360	IF(LINE(COL:COL).NE.'(') GOTO 430
	COL=COL+1
	PARCNT=1
370	IF(LINE(COL:COL).EQ.'(') PARCNT=PARCNT+1
	IF(LINE(COL:COL).EQ.')') PARCNT=PARCNT-1
	COL=COL+1
	IF(PARCNT.NE.0) GOTO 370
	IF(LINE(COL:COL).LT.'0'.OR.LINE(COL:COL).GT.'9') THEN
	    START=1
	    END=14
	    GOTO 130
	    ENDIF
	END1=INDEX(LINE(COL:LINLEN),',')+COL-2
	COL2=END1+2
	END2=INDEX(LINE(COL2:LINLEN),',')+COL2-2
	COL3=END2+2
	STS=VALUE(LINE(COL:END1),STMT1)
	IF(.NOT.STS) GOTO 430
	STS=VALUE(LINE(COL2:END2),STMT2)
	IF(.NOT.STS) GOTO 430
	STS=VALUE(LINE(COL3:LINLEN),STMT3)
	IF(.NOT.STS) GOTO 430
	INDX1=BSRCH(LABEL(1,1),NUMLAB,STMT1)
	INDX2=BSRCH(LABEL(1,1),NUMLAB,STMT2)
	INDX3=BSRCH(LABEL(1,1),NUMLAB,STMT3)
	IF(INDX1.EQ.0.OR.INDX2.EQ.0.OR.INDX3.EQ.0) GOTO 580
	STS=CVTNUM(LABEL(INDX1,2),CLAB,CLEN)
	LINE=LINE(1:COL-1)//CLAB(1:CLEN)//','
	END=COL+CLEN
	STS=CVTNUM(LABEL(INDX2,2),CLAB,CLEN)
	LINE=LINE(1:END)//CLAB(1:CLEN)//','
	END=END+CLEN+1
	STS=CVTNUM(LABEL(INDX3,2),CLAB,CLEN)
	LINE=LINE(1:END)//CLAB(1:CLEN)
	LINLEN=END+CLEN
	GOTO 430
C
C TYPE 12 - READ STATEMENT, TYPE 14 - WRITE STATEMENT
C
380	IF(LINE(COL:COL).NE.'(') GOTO 430
	OLDCOL=COL
	COL=COL+1
	PARCNT=1
390	IF(LINE(COL:COL).EQ.'(') PARCNT=PARCNT+1
	IF(LINE(COL:COL).EQ.')') PARCNT=PARCNT-1
	COL=COL+1
	IF(PARCNT.NE.0) GOTO 390
	IF(LINE(COL:COL).EQ.'=') GOTO 430
	COL=OLDCOL+1
	PARCNT=0
400	IF(LINE(COL:COL).EQ.','.AND.PARCNT.EQ.0) THEN
	    COL=COL+1
	    ELSE
	    IF(LINE(COL:COL).EQ.'(') PARCNT=PARCNT+1
	    IF(LINE(COL:COL).EQ.')') PARCNT=PARCNT-1
	    COL=COL+1
C
C THE FOLLOWING IS A KLUGE TO AVOID THE PROBLEM WHEN RANDOM ACCESS TYPE
C READ IS USED, I.E. READ(20'IREC,FMT)
C
	    IF(COL.GT.LINLEN) GOTO 430
	    GOTO 400
	    ENDIF
	IF(LINE(COL:COL).LT.'0'.OR.LINE(COL:COL).GT.'9') GOTO 410
	LOCOMA=INDEX(LINE(COL:LINLEN),',')
	LOCRPR=INDEX(LINE(COL:LINLEN),')')
	IF(LOCOMA.LT.LOCRPR) END=LOCOMA+COL-2
	IF(LOCOMA.EQ.0.OR.LOCOMA.GT.LOCRPR) END=LOCRPR+COL-2
	STS=VALUE(LINE(COL:END),STMT)
	IF(.NOT.STS) GOTO 430
	INDX=BSRCH(LABEL(1,1),NUMLAB,STMT)
	IF(INDX.EQ.0) GOTO 580
	STS=CVTNUM(LABEL(INDX,2),CLAB,CLEN)
	LINE=LINE(1:COL-1)//CLAB(1:CLEN)//LINE(END+1:LINLEN)
	LINLEN=COL+CLEN+LINLEN-END-1
410	COL=OLDCOL
	CALL STR$UPCASE(LYNE(1:LINLEN),LINE(1:LINLEN))
420	LOCERR=INDEX(LYNE(COL:LINLEN),'ERR=')
	LOCEND=INDEX(LYNE(COL:LINLEN),'END=')
	IF(LOCERR.EQ.0.AND.LOCEND.EQ.0) GOTO 430
	IF(LOCERR.EQ.0) LOCERR=99999
	IF(LOCEND.EQ.0) LOCEND=99999
	IF(LOCERR.LT.LOCEND) THEN
	    COL=LOCERR+COL+3
	    ELSE
	    COL=LOCEND+COL+3
	    ENDIF
	LOCOMA=INDEX(LINE(COL:LINLEN),',')
	LOCRPR=INDEX(LINE(COL:LINLEN),')')
	IF(LOCOMA.LT.LOCRPR) END=LOCOMA+COL-2
	IF(LOCOMA.EQ.0.OR.LOCOMA.GT.LOCRPR) END=LOCRPR+COL-2
	STS=VALUE(LINE(COL:END),STMT)
	IF(.NOT.STS) GOTO 430
	INDX=BSRCH(LABEL(1,1),NUMLAB,STMT)
	IF(INDX.EQ.0) GOTO 580
	STS=CVTNUM(LABEL(INDX,2),CLAB,CLEN)
	LINE=LINE(1:COL-1)//CLAB(1:CLEN)//LINE(END+1:LINLEN)
	LINLEN=COL+CLEN+LINLEN-END-1
	COL=COL+CLEN
	GOTO 420
C
C MERGE COMPRESSED LINE WITH ORIGINAL LINE(S)
C
430	PTR1=1
D	IF(DEBCOD.GT.0) THEN
D	    TMP=LINLEN
D	    IF(LINLEN.GT.72) TMP=72
D	    TYPE *,TMP,LINE(1:TMP)
D	    ENDIF
	LINFLG=0
440	READ(FIL3,10010)ORGLEN,ORGLIN
D	IF(DEBCOD.EQ.2) THEN
D	    TYPE *,ORGLEN,ORGLIN
D	    ENDIF
	IF (LYNE(1:1).EQ.'C'.OR.LYNE(1:1).EQ.'*') THEN
	    CALL WRTLIN(FIL4,ORGLIN(1:ORGLEN))
	    GO TO 110
	END IF
	PTR2=1
	PTR3=1
	COL=1
	QUOTE=.FALSE.
	IF (ORGLIN(1:1).EQ.TAB) THEN
	   IF (CHRTBL(ICHAR(ORGLIN(2:2))).EQ.NUMBER) THEN
	      COL=5
	   ELSE
	      COL=6
	   END IF
	   GO TO 500
	END IF
	IF (PTR1.LT.7.AND.LINE(1:5).NE.' ') THEN
	   IF (CHRTBL(ICHAR(ORGLIN(1:1))).EQ.ALPHA) THEN
	      IF (RJUST.EQ.0) THEN
	         IF (LABLEN+1.LT.6) THEN
	            NEWLIN(1:5)=ORGLIN(1:1)//LINE(1:4)
	            PTR3=LABLEN+2
	            COL=LABLEN+2
	         ELSE
	            GO TO 585
	         END IF
	      ELSE
	         IF (LINE(1:1).EQ.' ') THEN
	            NEWLIN(1:5)=ORGLIN(1:1)//LINE(2:5)
	            PTR3=6
	            COL=6
	         ELSE
	            GO TO 585
	         END IF
	      END IF
	   ELSE
	      NEWLIN(1:5)=LINE(1:5)
	      PTR3=LABLEN+1
	      COL=LABLEN+1
	   END IF
	   PTR1=6
C
C	   FIND FIRST NON-LABEL CHARACTER IN ORGLIN
C
	   PTR2=2
	   DO WHILE ((ORGLIN(PTR2:PTR2).EQ.' '.OR.
	1     CHRTBL(ICHAR(ORGLIN(PTR2:PTR2))).EQ.NUMBER)
	2     .AND.PTR2.LT.6)
	      PTR2 = PTR2 + 1
	   END DO
	   IF (ORGLIN(PTR2:PTR2).NE.TAB) THEN
	      PTR3=6
	      COL=6
	   END IF
	END IF
450	IF(ORGLIN(PTR2:PTR2).EQ.TAB.AND.COL.LT.7) THEN
	    COL=6
	    GOTO 500
	ENDIF
460	CHRIDX=LINE(PTR1:PTR1)
	IF(CHRTBL(BYTIDX).EQ.IGNORE.OR.CHRTBL(BYTIDX).EQ.CPYORG) THEN
	    PTR1=PTR1+1
	    IF(PTR1.LE.LINLEN) GOTO 460
	    GOTO 530
	    ENDIF
	CHRIDX=ORGLIN(PTR2:PTR2)
	IF(CHRTBL(BYTIDX).EQ.IGNORE) GOTO 510
D	IF(DEBCOD.EQ.1) THEN
D	    TYPE *,CHRIDX,BYTIDX,CHRTBL(BYTIDX),PTR1,PTR2,PTR3,COL
D	    ENDIF
	GOTO (470,480,470,500),CHRTBL(BYTIDX)-1
	STOP 'Internal error'
C
C ALPHABETIC AND SPECIAL CHARACTERS
C
470	NEWLIN(PTR3:PTR3)=ORGLIN(PTR2:PTR2)
	PTR3=PTR3+1
	IF((.NOT.QUOTE).AND.(ORGLIN(PTR2:PTR2).EQ.'!')) THEN
	    PTR2=PTR2+1
	    GOTO 520
	    ENDIF
	IF((ORGLIN(PTR2:PTR2).EQ.'''').AND.QUOTE) THEN
	    IF(ORGLIN(PTR2+1:PTR2+1).EQ.'''') THEN
		PTR2=PTR2+1
		NEWLIN(PTR3:PTR3)=ORGLIN(PTR2:PTR2)
		PTR3=PTR3+1
		GOTO 510
		ENDIF
	    ENDIF
	IF(ORGLIN(PTR2:PTR2).EQ.'''') QUOTE=.NOT.QUOTE
	IF((ORGLIN(PTR2:PTR2).NE.'''').AND.QUOTE) GOTO 510
	IF(COL.LE.6.AND.PTR1.GT.6) GOTO 510
	PTR1=PTR1+1
	IF(PTR1.LE.LINLEN) GOTO 510
	PTR2=PTR2+1
	GOTO 530
C
C NUMERIC CHARACTER
C
480	SPACNT=0
485	IF(COL.EQ.6.AND.PTR1.GT.6) GOTO 500
	IF(QUOTE) GOTO 500
	CHRIDX=ORGLIN(PTR2:PTR2)
	IF(CHRTBL(BYTIDX).EQ.NUMBER.OR.CHRTBL(BYTIDX).EQ.CPYORG) THEN
	    COL=COL+1
	    IF(COL.GT.72) GOTO 490
	    PTR2=PTR2+1
	    IF(PTR2.GT.ORGLEN) GOTO 490
	    IF(CHRTBL(BYTIDX).EQ.CPYORG) THEN
		SPACNT=SPACNT+1
		CHRIDX=ORGLIN(PTR2:PTR2)
		IF(CHRTBL(BYTIDX).EQ.NUMBER.OR.CHRTBL(BYTIDX).EQ.CPYORG) GOTO 485
		COL=COL-SPACNT
		PTR2=PTR2-SPACNT
		ELSE
		GOTO 480
		ENDIF
	    ENDIF
	COL=COL-1
	PTR2=PTR2-1
490	CHRIDX=LINE(PTR1:PTR1)
	IF(CHRTBL(BYTIDX).NE.NUMBER) GOTO 510
	NEWLIN(PTR3:PTR3)=LINE(PTR1:PTR1)
	PTR3=PTR3+1
	PTR1=PTR1+1
	IF(PTR1.LE.LINLEN) GOTO 490
	PTR2=PTR2+1
	GOTO 530
C
C COPY CHARACTER FROM ORIGINAL LINE
C
500	NEWLIN(PTR3:PTR3)=ORGLIN(PTR2:PTR2)
	PTR3=PTR3+1
C
C BUMP POINTER IN ORIGINAL LINE
C
510	PTR2=PTR2+1
	COL=COL+1
	IF(COL.LE.72.AND.PTR2.LE.ORGLEN) GOTO 450
520	IF(PTR2.LT.ORGLEN) THEN
	    NEWLIN(PTR3:)=ORGLIN(PTR2:ORGLEN)
	    PTR3=PTR3+ORGLEN-PTR2
	    ELSE
	    PTR3=PTR3-1
	    ENDIF
	CALL WRTLIN(FIL4,NEWLIN(1:PTR3))
	IF(PTR1.LE.LINLEN) GOTO 440
	GOTO 110
530	IF(PTR2.LE.ORGLEN) THEN
	    NEWLIN(PTR3:)=ORGLIN(PTR2:ORGLEN)
	    PTR3=PTR3+ORGLEN-PTR2
	    ELSE
	    PTR3=PTR3-1
	    ENDIF
	CALL WRTLIN(FIL4,NEWLIN(1:PTR3))
	GOTO 110
C
C FINISH UP MODULE
C
540	READ(FIL3,10010)ORGLEN,ORGLIN
	LINENO=LINENO+1
	CALL WRTLIN(FIL4,ORGLIN(1:ORGLEN))
	NUMLAB=0
	GOTO 50
550	CLOSE(UNIT=FIL1)
	CLOSE(UNIT=FIL2)
	CLOSE(UNIT=FIL3)
	CLOSE(UNIT=FIL4)
	GOTO 10
560	TYPE 10080,IFILE(1:IFILEN)
10080	FORMAT(' Error opening input file: ',A)
	GOTO 10
570	TYPE 10090,OFILE(1:OFILEN)
10090	FORMAT(' Error opening output file: ',A)
	GOTO 10
580	TYPE 10100,STMT
10100	FORMAT(' Original label: ',I5,', not found')
	TYPE '(XA)',LINE(1:LINLEN)
	GOTO 550
585	TYPE 11000,LINE(1:5),ORGLIN(1:ORGLEN)
11000	FORMAT (' Generated statement number: 'a,' is too wide',
	1	' for the DEBUG statement:'/xa)
	GO TO 550
590	CONTINUE
	END
	INTEGER FUNCTION VALUE(STRING,NUMBER)
C
C	COPYRIGHT (C) 1979
C	MANAGEMENT SCIENCE ASSOCIATES, INC.
C	5100 CENTRE AVENUE
C	PITTSBURGH, PENNA. 15232
C
C	AUTHOR:	MARK PILANT
C
C THIS FUNCTION CONVERTS THE STRING GIVEN TO AN ACTUAL NUMBER
C
	IMPLICIT INTEGER (A-Z)
	CHARACTER STRING*(*)
	VALUE=1
	CALL STR$TRIM(STRING,STRING,LENSTR)
	READ (STRING(1:LENSTR),'(I<LENSTR>)',ERR=10) NUMBER
	RETURN
10	VALUE=0
	RETURN
	END
	INTEGER FUNCTION GETLIN(UNIT,LINE,LENGTH)
C
C	COPYRIGHT (C) 1979
C	MANAGEMENT SCIENCE ASSOCIATES, INC.
C	5100 CENTRE AVENUE
C	PITTSBURGH, PENNA. 15232
C
C	AUTHOR:	MARK PILANT
C
	IMPLICIT INTEGER (A-Z)
C
C GET A LINE FROM THE FILE, TAKE CARE OF LEADING TABS (CONVERT TO SPACES
C AND PUT DATA INTO NICE COLUMNS), AND COMPRESS OUT ALL TABS AND SPACES
C AFTER COLUMN 7
C
	PARAMETER TAB=CHAR(9)
	CHARACTER LINE*(*),ORGLIN*100,HLDLIN(2)*100
	DIMENSION HLDLEN(2)
	LOGICAL QUOTE,HLDQOT(2)
	COMMON/FLAGS/ GOTLIN(2)
	LINE=' '
	LINLEN=0
	UN9=UNIT-9
	QUOTE=.FALSE.
	IF(GOTLIN(UN9).NE.0) GOTO 70
10	READ(UNIT,10000,END=90,ERR=80)ORGLEN,ORGLIN
10000	FORMAT(Q,A)
	CALL STR$TRIM(ORGLIN,ORGLIN,ORGLEN)
	IF(ORGLEN.LT.1)ORGLEN=1
	HLDLIN(UN9)=' '
	COL=1
	START=1
	IF(ORGLIN(1:1).EQ.TAB) THEN
	    IF(ORGLIN(2:2).GE.'0'.AND.ORGLIN(2:2).LE.'9') THEN
	        COL=6
	    ELSE
	        COL=7
	    END IF
	    START=2
	END IF
	POS=COL-1
	TMPIGN=0
	DO 50 I=START,ORGLEN
	POS=POS+1
	IF(ORGLIN(I:I).EQ.TAB.AND.COL.LT.7) THEN
	    COL=7
	    POS=6
	    GOTO 50
	END IF
	IF(POS.LE.6) GOTO 40
	IF(TMPIGN.NE.0) THEN
	    TMPIGN=0
	    GOTO 50
	END IF
	IF(COL.EQ.7) THEN
	    IF (HLDLIN(UN9)(6:6).EQ.'0'.OR.
	1	HLDLIN(UN9)(6:6).EQ.' '.OR.
	2	HLDLIN(UN9)(1:1).EQ.'C'.OR.
	3	HLDLIN(UN9)(1:1).EQ.'c'.OR.
	4	HLDLIN(UN9)(1:1).EQ.'*') THEN
		IF(QUOTE) THEN
		    IF(UN9.EQ.2) TYPE '(XA,A)',
	1		'Unsatisfied quote near: ',
	2		ORGLIN(1:ORGLEN)
		    QUOTE = .FALSE.
		    HLDQOT(UN9)=QUOTE
		END IF
	    END IF
	END IF
	IF (COL.GT.6) THEN
	    IF((ORGLIN(I:I).NE.'''').AND.QUOTE) GOTO 50
	    IF(ORGLIN(I:I).EQ.'''') THEN
		IF(QUOTE) THEN
		    IF(I+1.LE.ORGLEN) THEN
			IF(ORGLIN(I+1:I+1).EQ.'''') THEN
			    TMPIGN=1
			    GOTO 50
			END IF
		    END IF
		END IF
		QUOTE=.NOT.QUOTE
		HLDQOT(UN9)=QUOTE
	    END IF
	END IF
	IF(ORGLIN(I:I).EQ.TAB) ORGLIN(I:I)=' '
	IF(COL.GE.7.AND.ORGLIN(I:I).EQ.' ') GOTO 50
	IF(ORGLIN(I:I).EQ.'!') GOTO 60
	IF(POS.GT.72) GOTO 50
40	HLDLIN(UN9)(COL:COL)=ORGLIN(I:I)
	COL=COL+1
50	CONTINUE
60	HLDLEN(UN9)=COL-1
	IF((HLDLIN(UN9)(6:6).EQ.' '.OR.
     1      HLDLIN(UN9)(6:6).EQ.'0'.OR.
     2	    HLDLIN(UN9)(1:1).EQ.'c'.OR.
     3	    HLDLIN(UN9)(1:1).EQ.'C'.OR.
     4	    HLDLIN(UN9)(1:1).EQ.'*'.OR.
     5	    HLDLEN(UN9).LE.6).AND.LINLEN.GT.0) THEN
	    LENGTH=LINLEN
	    GOTLIN(UN9)=1
	    GETLIN=1
	    RETURN
	END IF
70	IF(LINLEN.EQ.0) THEN
	    BEG=1
	ELSE
	    BEG=7
	END IF
	QUOTE=HLDQOT(UN9)
	LINE(LINLEN+1:)=HLDLIN(UN9)(BEG:HLDLEN(UN9))
	LINLEN=LINLEN+HLDLEN(UN9)-BEG+1
	GOTO 10
80	GETLIN=0
	RETURN
90	IF(GOTLIN(UN9).NE.0) THEN
	    LENGTH=LINLEN
	    GOTLIN(UN9)=0
	    GETLIN=1
	    RETURN
	END IF
	GETLIN=-1
	RETURN
	END
	INTEGER FUNCTION BSRCH(TABLE,LIMIT,ENTRY)
C
C	COPYRIGHT (C) 1979
C	MANAGEMENT SCIENCE ASSOCIATES, INC.
C	5100 CENTRE AVENUE
C	PITTSBURGH, PENNA. 15232
C
C	AUTHOR:	MARK PILANT
C
C THIS FUNCTION PERFORMS A BINARY SEARCH ON THE TABLE FROM 1 TO LIMIT.
C THE FUNCTION RETURNS THE INDEX IF THE ENTRY IS FOUND, OR 0 IF IS NOT
C FOUND.
C
	IMPLICIT INTEGER(A-Z)
	DIMENSION TABLE(1)
	START=1
	END=LIMIT
10	MID=START+(END-START)/2
	IF(TABLE(MID)-ENTRY)20,50,30
20	START=MID+1
	GOTO 40
30	END=MID-1
40	IF(START.LE.END) GOTO 10
	BSRCH=0
	RETURN
50	BSRCH=MID
	RETURN
	END
	INTEGER FUNCTION CVTNUM(NUMBER,STRING,LENGTH)
C
C	COPYRIGHT (C) 1979
C	MANAGEMENT SCIENCE ASSOCIATES, INC.
C	5100 CENTRE AVENUE
C	PITTSBURGH, PENNA. 15232
C
C	AUTHOR:	MARK PILANT
C
C THIS FUNCTION CONVERTS THE NUMBER TO A STRING
C
	IMPLICIT INTEGER (A-Z)
	CHARACTER STRING*(*)
	LENGTH=IFIX(ALOG10(FLOAT(NUMBER))+1)
	WRITE (STRING,'(I<LENGTH>)',ERR=10) NUMBER
	CVTNUM=1
	RETURN
10	CVTNUM=0
	RETURN
	END
	SUBROUTINE COLPRI(UNIT,LIMIT,ARRAY)
C
C	COPYRIGHT (C) 1979
C	MANAGEMENT SCIENCE ASSOCIATES, INC.
C	5100 CENTRE AVENUE
C	PITTSBURGH, PENNA. 15232
C
C	AUTHOR:	MARK PILANT
C
C THIS ROUTINE PRINTS THE ARRAY IN COLUMNS ON THE PAGE.
C THE NUMBER OF COLUMNS IS DETERMINED BY THE VARIABLE 'COLUMN'.
C
C THE FORMAT OF THE TABLE IS:
C
C NNNNN  NNNNN    NNNNN  NNNNN    NNNNN  NNNNN    ...
C
	PARAMETER COLUMN=8		!NUMBER OF DOUBLE COLUMNS TO PRINT
	PARAMETER LENGTH=55		!NUMBER OF ROWS ON A PAGE
	IMPLICIT INTEGER (A-Z)
	CHARACTER TITLE1*12,TITLE2*12,FMT*29
	DIMENSION PTR(COLUMN),ARRAY(1)
	DATA TITLE1/'Line  Number'/
	DATA TITLE2/' old    new '/
	DATA FMT/'(1H1,X(A12,4X)/1X,X(A12,4X)/)'/
	PAGES=(LIMIT+LENGTH*COLUMN-1)/(LENGTH*COLUMN)
	DO 80 I=1,PAGES
C
C SET THE START INDEX FOR EACH COLUMN
C
	DO 10 J=1,COLUMN
	PTR(J)=(I-1)*(LENGTH*COLUMN)+(J-1)*LENGTH+1
10	CONTINUE
C
C FIGURE OUT HOW NAME TITLES TO PRINT
C
	DO 20 K=1,COLUMN
	IF(PTR(K).GT.LIMIT) GOTO 30
20	CONTINUE
30	CNT=K-1
	ENCODE(1,10000,FMT(6:6))CNT
10000	FORMAT(I1)
	ENCODE(1,10000,FMT(19:19))CNT
C
C PRINT THE COLUMN TITLES
C
	WRITE(UNIT,FMT)(TITLE1,L=1,CNT),(TITLE2,L=1,CNT)
C
C PRINT OUT THE DATA
C
	DO 70 K=1,LENGTH
	DO 40 L=1,COLUMN
	IF(PTR(1).GT.LIMIT) GOTO 90
	IF(PTR(L).GT.LIMIT) GOTO 50
40	CONTINUE
50	CNT=L-1
	WRITE(UNIT,10010)(ARRAY(PTR(M)),ARRAY(PTR(M)+10000),M=1,CNT)
10010	FORMAT(1X,9(I5,2X,I5,4X))
C
C SET FOR NEXT VALUE
C
	DO 60 M=1,COLUMN
	PTR(M)=PTR(M)+1
60	CONTINUE
70	CONTINUE
C
C NEXT PAGE
C
80	CONTINUE
C
C DONE WITH LIST
C
90	WRITE(UNIT,10020)
10020	FORMAT(1H1)
	RETURN
	END
	SUBROUTINE WRTLIN(UNIT,LINE)
C
C	COPYRIGHT (C) 1979
C	MANAGEMENT SCIENCE ASSOCIATES, INC.
C	5100 CENTRE AVENUE
C	PITTSBURGH, PENNA. 15232
C
C	AUTHOR:	MARK PILANT
C
C THIS ROUTINE WRITES OUT THE LINE TO THE SPECIFIED UNIT. HOWEVER, IF THE
C LINE GOES BEYOND COLUMN 72, IT IS BROKEN AT THE LAST DELIMITER AND A
C CONTINUATION LINE IS INSERTED.
C
	IMPLICIT INTEGER (A-Z)
	PARAMETER TABCH=CHAR(9)
	CHARACTER LINE*(*),CONLIN*100
	DIMENSION SWTCHV(6)
	LOGICAL QUOTE
	EQUIVALENCE (SWTCHV(1),FMTBEG),(SWTCHV(2),INCRMT),
     1		    (SWTCHV(4),LINBEG),(SWTCHV(5),LSTFLG),
     2		    (SWTCHV(6),SYMFLG)
	COMMON/FLAGS/ GOTLIN(2),LINFLG,SWTCHV
	COMMON/UNITS/ FIL1,FIL2,FIL3,FIL4,FIL5
	COMMON LINENO
	LINLEN=LEN(LINE)
	IF(LINE(1:1).EQ.'C'.OR.LINE(1:1).EQ.'c') GOTO 30
	TAB=0
	COL=1
	START=1
	IF(LINE(1:1).EQ.TABCH) THEN
	    TAB=1
	    COL=7
	    IF(LINE(2:2).GE.'0'.AND.LINE(2:2).LE.'9') COL=6
	    START=2
	END IF
	QUOTE=.FALSE.
	TMPIGN=0
	DO 20 I=START,LINLEN
	IF(TMPIGN.NE.0) THEN
	    TMPIGN=0
	    GOTO 10
	END IF
	IF((LINE(I:I).EQ.'!').AND.(.NOT.QUOTE)) GOTO 30
	IF(LINE(I:I).EQ.'''') THEN
	    IF(I+1.LE.LINLEN) THEN
		IF(LINE(I+1:I+1).EQ.'''') THEN
		    TMPIGN=1
		    GOTO 10
		END IF
		END IF
	    QUOTE=.NOT.QUOTE
	END IF
	IF(LINE(I:I).EQ.TABCH.AND.COL.LT.7) THEN
	    TAB=1
	    COL=7
	    GOTO 20
	END IF
10	COL=COL+1
	IF(COL.GT.72) GOTO 40
20	CONTINUE
30	WRITE(UNIT,10000)LINE(1:LINLEN)
10000	FORMAT(A)
	IF(LSTFLG.EQ.0) RETURN
	IF(LINFLG.EQ.0.AND.LINE(1:1).NE.'C'
	1	.AND.LINE(1:1).NE.'c') THEN
	    WRITE(FIL5,10010)LINENO,LINE(1:LINLEN)
10010	    FORMAT(1X,I5,1H	,A)
	    LINFLG=-1
	ELSE
	    WRITE(FIL5,10020)LINE(1:LINLEN)
10020	    FORMAT(6X,1H	,A)
	END IF
	RETURN
40	CONTINUE
	IF(.NOT.QUOTE) GOTO 60
50	IF(LINE(I:I).EQ.'''') THEN
	    IF(I-1.GE.1) THEN
		IF(LINE(I-1:I-1).EQ.'''') THEN
		    I=I-2
		    GOTO 50
		END IF
		END IF
	    IF(I+1.LE.LINLEN) THEN
		IF(LINE(I+1:I+1).EQ.'''') THEN
		    I=I+2
		    GOTO 50
		END IF
		END IF
	    END=I-1
	    GOTO 70
	END IF
	I=I-1
	GOTO 50
60	IF(I.GE.1) THEN
	    IF(LINE(I:I).GE.'0'.AND.LINE(I:I).LE.'9'.OR.
     1	       LINE(I:I).GE.'A'.AND.LINE(I:I).LE.'Z'.OR.
     2	       LINE(I:I).GE.'a'.AND.LINE(I:I).LE.'z') THEN
		I=I-1
		GOTO 60
		END IF
	    END=I
	END IF
70	WRITE(UNIT,10000)LINE(1:END)
	IF(LSTFLG.EQ.0) GOTO 80
	IF(LINFLG.EQ.0.AND.LINE(1:1).NE.'C'
	1	.AND.LINE(1:1).NE.'c') THEN
	    WRITE(FIL5,10010)LINENO,LINE(1:END)
	    LINFLG=-1
	ELSE
	    WRITE(FIL5,10020)LINE(1:END)
	END IF
80	IF(END.EQ.LINLEN) RETURN
	IF(TAB.EQ.0) THEN
	    WRITE(UNIT,10030)LINE(END+1:LINLEN)
10030	    FORMAT('     *',A)
	    IF(LSTFLG.NE.0) WRITE(FIL5,10040)LINE(END+1:LINLEN)
10040	    FORMAT(' 	     *',A)
	END IF
	IF(TAB.NE.0) THEN
	    WRITE(UNIT,10050)LINE(END+1:LINLEN)
10050	    FORMAT('     *	',A)
	    IF(LSTFLG.NE.0) WRITE(FIL5,10060)LINE(END+1:LINLEN)
10060	    FORMAT(' 	     *	',A)
	END IF
	RETURN
	END
