$SAVE_VERIFY = 'F$VERIFY("NO")'
$!
$! xlib:  VAX/VMS Library Command Interpreter (Version 3.0)
$!
$!	Written by Gary L. Gilliland
$!	           Molecular Structure Section
$!                 LMB,NIADDK,NIH
$!                 Bld. 2, Rm. 316
$!                 Bethesda MD 
$!
$!	Version 3.0 incorporates modifications by 
$!		   Norman Berk
$!		   Bld 235, Rm A106
$!		   Reacter Radiation Division
$!                 National Bureau of Standards
$!                 Washington, D. C.  20234
$!
$!	Maintained at NIH by
$!		   Gerson H Cohen
$!	           Molecular Structure Section
$!                 LMB,NIADDK,NIH
$!                 Bld. 2, Rm. 312
$!                 Bethesda MD  20205
$!
$!
$option_table1 := 2LE4EXIT1E1F2FT2FC3FCD4FCLR4FCNI2FD2FL3FLL2FR1H2HC1L3LCF3LCO4LCRF4LCRO3LEF3LES3LEO2ED3LED9
$option_table2 := 3LIF3LIO3LLF3LLO2LR3LRF3LRO2PF2PL2TF2TL4FLLB4FLLD3MAC3RUN3LDO3LDF5FLLBD2EM2ES3RNE3PFL3TFL0
$type sys$input

	VAX/VMS Library Command Interpreter  (Version 3.0)

$!
$!
!	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!	Original code by G Gilliland, based on FORTUSER from VAX manual 2B.
!	The additions of N BERK includes library defaults, command parameters
!	The additions of G H Cohen permit change of file type
!
!	Some special features of this version:
!
!	1) there are no initial prompts for LIBRARY and FILE.
!	2) Unless overridden, the default library name is the name of the 
!	   current subdirectory (or main directory).  E.g. if the default is
!	   [NORM.MATH], the default library name is MATH; if the default
!	   is [NORM], the library name is NORM.  The default library name
!	   always tracks the directory default, even when you change
!	   defaults from within the library command procedure. 
!	3) The F, FT and L commands accept names as parameters.
!	   E.g. F MYFILE is equivalent to F followed by the MYFILE
!	   response to the FILE: prompt.  Simlilarly L MYLIB automatically
!	   assigns MYLIB to the default library name.  F or L without
!	   parameters cause prompts for names as usual.
!	   F ?, FT ? and L ? display the current default names.
!	   (CR response to FILE: causes exit.)
!	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!
$	name = ""  ! initialize for first test at $F0
$	f_type = ".FOR"	! default file type is .FOR (FORTRAN)
$!
$ prompt := NEXT
$ CHECK_LIB: ! make default library name the same as default (sub)directory.
$	default_directory = f$string(f$directory())
$	a_d = default_directory - "[" - "]"  ! directory without brackets
$  GET_LAST_SD:
$	main_dir_name = f$extract(0,f$locate(".",a_d),a_d) ! part before "."
$	b_d = f$extract(1+f$locate(".",a_d),f$length(a_d),a_d) ! a_d - main.
$	sub_dir_name = b_d - f$extract(f$locate(".",b_d),f$length(b_d),b_d)
$	a_d = b_d
$       if sub_dir_name .nes. "" then goto GET_LAST_SD
$	library_lib = main_dir_name
$	write sys$output "Default Library is: ''library_lib'"
$	file = library_lib
$	write sys$output "Default File Name is: ''file'"
$	write sys$output "Default File Type is: ''f_type'"
$	write sys$output ""
$!
$goto NEXT
$!
$!Main command parsing routine.  The routine compares the current
$!command against the options in the option table.  When it finds
$!a match, it branches to the appropriate label.
$!
$NEXT:
$	set control_y
$!	on control_y then goto EXIT0 ! to avoid infinite loops if screw up.
$	on warning then goto NEXT	!If any, reset prompt
$!
$	if default_directory .nes. f$string(f$directory()) then goto CHECK_LIB
$!
$	on control_y then goto NEXT
$!
$	inquire/nopunctuation command "lib> "
$	if command .eqs. "" then goto NEXT
$!
$ CHECK_FOR_PARAMETER:
$	response_size = f$length(command)
$	blank_offset = f$locate(" ",command)
$	command_parameter = f$extract(blank_offset,response_size,command)
$	command = command - command_parameter
$	name = command_parameter
$!
$ NOW_CHECK_COMMAND:
$!
$	command_size = 'f$length(command)'
$	command_search= f$string(command_size) + command
$	table_number = 1	
$!
$ CHECK_NEXT:
$	table_char    = f$string('table_number')
$	option_table  = option_table'table_char'
$	option_length = f$length(option_table) - 1
$	command_found = f$locate(command_search,option_table)
$	if command_found .lt. option_length -
		then goto 'command'0
$	option_end    = 'f$extract(option_length,1,option_table)'
$	if option_end .eq. 0 then goto INVALID_COMMAND
$	table_number = table_number + 1
$	goto CHECK_NEXT
$!
$INVALID_COMMAND:
$	assign/user_mode sys$command: sys$input:
$	command = command + command_parameter
$	'command'  
$	goto NEXT
$!
$!
$H0:
$	type sys$input
	The commands that you can enter are:
	
	
  
		E - edit
	
	E	edit the source with EDT/SLAVE
	ED	edit the source with EDT/SLAVE
	EM      edit the source with MCR EDIT
	ES	edit the source with SOS

      EXIT	return to system
  
	F	enter file name of source
		F takes file name as parameter
	
	FT	enter new file type (default is .FOR)
		FT takes type (include ".") as parameter

		F - fortran
	
	FC	compile the fortran source 
	FCD	compile the fortran source for running under the debugger
	FCNI	compile the source with NOI4
	FCLR	compile, link and run the fortran source program
	FD 	run the program under control of the debugger
	FL	link the program to produce an executable image
	FLL	link the object file (main) with the specified 
		library.
	FLLB	link the object file (main) with a prompt to 
		include a block data file from the library.
	FLLBD	link the object file (main) with  a prompt to
		include a block data file from the library for use
		with the debugger.
	FLLD	link the object file (main) with the specified
		library for use with the debugger.
	FR	run the program's executable image
  
		H - Help
	
	H	type this Help message
	HC	type the command list
  
		L - library
	
	L	input a new default name for the Fortran and Object
		libraries. L takes name as parameter
	LCF	compress the specified fortran library
	LCO 	compress the specified object library
	LCRF	create a text library and insert the source module
		into this library
	LCRO	create an object library and insert the object module
		into this library
	LDF	delete specified file name from the fortran library
	LDO	delete specified file name from the object library
	LE	extracts the specified file from the fortran library
		and invokes the EDT/SLAVE editor.
	LED	extracts the specified file from the fortran library
		and invokes the EDT editor.
	LEF	extracts the specified source file from the fortran library
	LEO	extracts the specified object file from the object library
	LES	extracts the specified file from the fortran library
		and invokes the SOS editor
	LIF	inserts source file into the specified fortran library
	LIO	inserts object module into the specified object library
	LLF	list the specified fortran library
	LLO	list the specified object library
	LR	replaces or inserts the object module and fortran source
		into the appropriate libraries.
		Both libraries must have the same name prefix.
	LRF	replaces or inserts the source file into the specified
		text library
	LRO	replaces or inserts the object module into the object library
	 
		M - macro
	
	MAC	assemble macro source of file
	
		P - print
	
	PF	print fortran source of file
	PFL     extract fortran file from library, print it, then
		delete it
	PL	queue the most recent listing file for printing
	
		R - run
	
	RUN	run executable image ... with debugger if linked /debug
	
		T - type
	
	TF	type the source file at the terminal
	TFL	extract fortran file from library, list it, then
		delete it
	TL	type the compiler listing at the terminal
 
  
$!
$goto 'prompt'
$!
$HC0:
$	type sys$input
	
	The commands that you may enter are:
	(= designates commands that accept a file name as a parameter)
  
	     edit:	E	ED	ES	EM
	     exit:      EXIT
	     file:	F=
	file_type:	FT=
	  fortran:	FC	FCD 	FCLR	FCNI	FD	FL
			FLL	FLLB	FLLBD	FLLD	FR
	     help:	H	HC
	  library:	L=	LCF	LCO	LCRF	LCRO
			LDF	LDO	LE	LED	LEF
			LEO	LES	LIF	LIO	LLF	LLO
			LR	LRF	LRO
	   macro:	MAC	
	   print:	PF	PFL=	PL
	     run:	RUN
	    type:	TF	TFL=	TL
	
	After entering the library and file you will be working with
	 type H for more information about the commands
	
$!
$goto 'PROMPT'
$!
$$D0:
$	dir
$	goto NEXT
$!
$DCL0:
$	inquire dcl_comd "Enter command"
$	assign/user_mode sys$command: sys$input:
$	'dcl_comd'
$	goto NEXT
$!
$E0:
$	assign/user_mode sys$command: sys$input:
$	set nocontrol_y		!Must disable CTRL/Y for EDT
$	edd 'file''f_type'
$	goto NEXT
$!
$ED0:
$	assign/user_mode sys$command: sys$input:
$	set nocontrol_y		!Must disable CTRL/Y for EDT
$	edt/command:edt$ 'file''f_type'
$	goto NEXT
$!
$EM0:
$	assign/user_mode sys$command: sys$input:
$	set nocontrol_y		!Must disable CTRL/Y for MCR EDIT
$	mcr edi 'file''f_type'
$	goto NEXT
$!
$ES0:
$	assign/user_mode sys$command: sys$input:
$	set nocontrol_y		!Must disable CTRL/Y for SOS
$	edit 'file''f_type'
$	goto NEXT
$!
$F0:
$	if f$string(name) .nes. " ?" then goto NEW_FILE
$	write sys$output "Default File is: ''file'"
$	goto NEXT
$  NEW_FILE:
$	file = name - " "	! Remove leading space
$	if file .eqs. "" then inquire file "FILE_NAME (<CR> exits procedure)"
$	if file .eqs. "" then goto EXIT0
$	file = f$parse(file,,,"NAME")
$	if file .nes. "" then goto NEXT
$!
$	write sys$output "Illegal file name, enter name portion only!"
$	write sys$output ""
$	write sys$output " For example:  ALPHA"
$	write sys$output ""
$	name = ""
$	goto NEW_FILE
$!
$FT0:
$	if f$string(name) .nes. " ?" then goto NEW_TYPE
$	write sys$output "Default File Type is: ''f_type'"
$	goto NEXT
$  NEW_TYPE:
$	f_type = name - " "	! Remove leading space
$	if f_type .eqs. "" then inquire f_type -
		"FILE_TYPE (<CR> exits procedure)"
$	if f_type .eqs. "" then goto EXIT0
$	if f$extract(0,1,f_type) .nes. "." then goto TYPE_ERR
$	if f$locate(".",f$extract(1,3,f_type)) .lt. (f$length(f_type)-1) then -
		goto TYPE_ERR
$	f_type = f$parse(f_type,,,"TYPE")
$	if f_type .nes. "" then goto NEXT
$!
$  TYPE_ERR:
$	write sys$output "Illegal file type, enter type portion only!"
$	write sys$output ""
$	write sys$output " For example:  .FOR"
$	write sys$output ""
$	name = ""
$	goto NEW_TYPE
$!
$FC0:
$	fortran/list/cross 'file''f_type'
$	goto NEXT
$FCD0:
$	fortran/list/nooptimize/object/debug/show=include/cross/check -
		'file''f_type'
$	goto next
$!
$FCLR0:
$	fortran/list/object/cross 'file''f_type'
$	link/debug 'file'
$	purge 'file'.*/keep=2
$	run/nodebug 'file'
$	goto NEXT
$!
$FCNI0:
$	fortran/lis/cross/noi4 'file''f_type'
$	goto NEXT
$!
$FD0:
$	assign/user_mode sys$command: sys$input
$	run 'file'
$	goto next
$!
$FL0:
$	link 'file'/debug
$	purge 'file'.*/keep=2
$	goto NEXT
$!
$FLLB0:
$	inquire block_data "block data name"
$	assign/user 'library_lib' lnk$library
$	link/map/exe='file' 'library_lib'/include=('file','block_data')
$	goto NEXT
$!
$FLLBD0:
$	inquire block_data "block data name"
$	assign/user 'library_lib' lnk$library
$	link/map/exe='file'/debug 'library_lib'/include=('file','block_data')
$	goto NEXT
$!
$FLL0:
$	assign/user 'library_lib' lnk$library
$	link/map/cross/exe='file' 'library_lib'/include='file'
$	goto NEXT
$
$FLLD0:
$	assign/user 'library_lib' lnk$library
$	link/map/exe='file'/debug 'library_lib'/include='file'
$	goto NEXT
$!
$FR0:
$	assign/user_mode sys$command: sys$input:
$	run/nodebug 'file'
$	goto NEXT
$!
$L0:
$	if f$string(name) .nes. " ?" then goto NEW_LIB
$	write sys$output "Default Library is: ''library_lib'"
$	goto NEXT
$  NEW_LIB:
$	library_lib = name - " "	! Remove leading space
$	if library_lib .eqs. "" then -
	inquire library_lib -
	"New Name for Fortran and Object Libraries (<CR> exits procedure)"
$	if library_lib .eqs. "" then goto EXIT0
$	library_lib = f$parse(library_lib,,,"NAME")
$	if library_lib .nes. "" then goto NEXT
$!
$	write sys$output "Illegal library name, enter name portion only!"
$	write sys$output ""
$	write sys$output " For example:  ALPHA"
$	write sys$output ""
$	name = ""
$	goto NEW_FILE
$!
$LCF0:
$	library/compress/log/text 'library_lib'
$	purge 'library_lib'.tlb
$	goto NEXT
$!
$LCO0:
$	library/compress/log 'library_lib'
$	purge 'library_lib'.olb
$	goto NEXT
$!
$LCRF0:
$	library/create/log/text 'library_lib' 'file''f_type'
$  	delete 'file''f_type';
$	goto NEXT
$!
$LCRO0:
$	library/create/log 'library_lib' 'file'
$	delete 'file'.obj;
$	goto NEXT
$!
$LDF0:
$	library/delete='file'/text/log 'library_lib'
$	goto NEXT
$!
$LDO0:
$	library/delete='file'/log      'library_lib'
$	goto NEXT
$!
$LED0:
$	library/log/text/extract='file'/output='file'.for 'library_lib'
$	assign/user_mode sys$command: sys$input:
$	set nocontrol_y		!Must disable CTRL/Y for EDT
$	edt/command:edt$ 'file''f_type'
$	goto NEXT
$!
$LE0:
$	library/log/text/extract='file'/output='file''f_type' 'library_lib'
$	assign/user_mode sys$command: sys$input:
$	set nocontrol_y		!Must disable CTRL/Y for EDT
$	edd 'file''f_type'
$	goto NEXT
$!
$LEF0:
$	library/log/text/extract='file'/output='file''f_type' 'library_lib'
$	goto NEXT
$!
$LEO0:
$	library/log/extract='file'/output='file'.obj 'library_lib'
$	goto NEXT
$!
$LES0:
$	library/log/text/extract='file'/output='file''f_type' 'library_lib'
$	assign/user_mode sys$command: sys$input:
$	set nocontrol_y		!Must disable CTRL/Y for SOS
$	edit/sos 'file''f_type'
$	goto NEXT
$!
$LIF0:
$	library/insert/text/log 'library_lib' 'file''f_type'
$  	delete 'file''f_type';
$	goto NEXT
$!
$LIO0:
$	library/insert/log 'library_lib' 'file'
$	delete 'file'.obj;
$	goto NEXT
$!
$LLF0:
$	library/list/full/log/text 'library_lib'
$	goto NEXT
$!
$LLO0:
$	library/list/full/log 'library_lib'
$	goto NEXT
$!
$LR0:
$	library/replace/log 'library_lib' 'file'
$	delete 'file'.obj;*
$	library/replace/log/text 'library_lib' 'file''f_type'
$  	delete 'file''f_type';*
$	goto NEXT
$!
$LRF0:
$	library/replace/log/text 'library_lib' 'file''f_type'
$  	delete 'file''f_type';*
$	goto NEXT
$!
$LRO0:
$	library/replace/log 'library_lib' 'file'
$	delete 'file'.obj;*
$	goto NEXT
$!
$MAC0:
$	macro 'file''f_type'
$	goto NEXT
$!
$PF0:
$	print 'file''f_type'
$	goto NEXT
$!
$PFL0:
$	if name .eqs. "" then goto PRINT_FILE
$	library/log/text/extract='name'/output='name''f_type' 'library_lib'
$	print 'name''f_type'
$	delete 'name''f_type';
$	goto NEXT
$    PRINT_FILE:
$	library/log/text/extract='file'/output='file''f_type' 'library_lib'
$	print 'file''f_type'
$	delete 'file''f_type';
$	goto NEXT
$!
$PL0:
$	print/noheader/delete 'file'.lis
$	goto NEXT
$!
$RNE0:
$	rename 'file'.exe exe$:'file'.exe
$	goto NEXT
$!
$RUN0:
$	assign/user_mode sys$command: sys$input:
$	run 'file'
$	goto NEXT
$!
$TF0:
$	type 'file''f_type'
$	goto NEXT
$!
$TFL0:
$	if name .eqs. "" then goto TYPE_FILE
$	library/log/text/extract='name'/output='name''f_type' 'library_lib'
$	assign/user_mode sys$command sys$input
$	list 'name''f_type'
$	delete 'name''f_type';
$	goto NEXT
$   TYPE_FILE:
$	library/log/text/extract='file'/output='file''f_type' 'library_lib'
$	assign/user_mode sys$command sys$input
$	list 'file''f_type'
$	delete 'file''f_type';
$!
$TL0:
$	type 'file'.lis
$	goto NEXT
$!
$EXIT0:
$	if SAVE_VERIFY then set verify
