C TIMER.FOR	-	FORTRAN main program of the TIMER Utility
C			Will access the VMS timer queue and print
C			to SYS$OUTPUT information from all TQEs
C			representing Process Timer Requests and
C			Scheduled Wakeup Requests.
C
C			CMKRNL Privilege is required to run TIMER
C
C
C		Written by:	Clair Garman
C				Digital Equipment Corporation
C				DC Educational Services
C
C
C
	IMPLICIT INTEGER (S,C)
C
	BYTE		SETIMR_FLAG,SCHDWK_FLAG
	INTEGER*2	WD_STORAGE(600)
	INTEGER*4	STORAGE(300),TIMLEN,ENTRY /1/,CURRENT_TIME(2)
	EQUIVALENCE	(WD_STORAGE,STORAGE)
	CHARACTER	ALL*3 /'ALL'/,  SETIMR*6 /'SETIMR'/,
	1		SCHDWK*6 /'SCHDWK'/, TIMBUF*30
C
	COMMON		STORAGE,SETIMR_FLAG,SCHDWK_FLAG
C
	EXTERNAL	TIMERPROC
	INCLUDE		'($SSDEF)'
	PARAMETER	(CLI$_PRESENT='3FD19'X)
	PARAMETER	(CLI$_DEFAULTED='3FD21'X)
	PARAMETER	(CLI$_IVKEYW='38060'X)
C
C
C
C Determine which qualifier has been used with the command and set
C	the appropriate flag
C
	I = CLI$PRESENT(SETIMR)
		IF (I.EQ.CLI$_PRESENT) GOTO 110
	I = CLI$PRESENT(SCHDWK)
		IF (I.EQ.CLI$_PRESENT) GOTO 120
	I = CLI$PRESENT(ALL)
		IF ((I.EQ.CLI$_PRESENT).OR.(I.EQ.CLI$_DEFAULTED)) GOTO 100
	CALL LIB$STOP(%VAL(CLI$_IVKEYW))	!Invalid qualifier
C
100	SETIMR_FLAG = 1
	SCHDWK_FLAG = 1
	GOTO 140
C
110	SETIMR_FLAG = 1
	GOTO 140
C
120	SCHDWK_FLAG = 1
C
C
C
C Execute a MACRO procedure in KERNEL mode to gather the data from the
C	VMS Timer Queue
C
140	KRNL_RET = SYS$CMKRNL (TIMERPROC,)
		IF(.NOT.KRNL_RET) CALL LIB$STOP(%VAL(I))
C
C
C
C Print selected data from the timer queue entries written to STORAGE
C	by the above MACRO procedure.  The formats for the entries are
C	as follows:
C
C	     SETIMR			    SCHDWK
C	|---------------|		|---------------|
C	|  EFN	|   1	|		|	|   2	|
C	|---------------|		|---------------|
C	|		|		|		|
C	|---  TIME   ---|		|---  TIME   ---|
C	|		|		|		|
C	|---------------|		|---------------|
C	|      PID	|		|      PID	|
C	|---------------|		|---------------|
C	|    ASTADR	|		|		|
C	|---------------|		|---  DELTA  ---|
C	|    ASTPRM	|		|		|
C	|---------------|		|---------------|
C
C
	DO WHILE (STORAGE(ENTRY) .NE. 0)
C
	IF (WD_STORAGE(2*ENTRY-1) .EQ. 1) THEN	!SETIMR Entry
C
C Print to SYS$OUTPUT from a SETIMR entry - skip if less than current time
C
	I = SYS$GETTIM(CURRENT_TIME)
		IF(.NOT.I) CALL LIB$STOP(%VAL(I))
		IF ((CURRENT_TIME(1) .EQ. STORAGE(ENTRY+1))  .AND.
	1	    (CURRENT_TIME(2) .EQ. STORAGE(ENTRY+2))) GOTO 299
C
	I = SYS$ASCTIM (TIMLEN,TIMBUF,STORAGE(ENTRY+1),)
		IF(.NOT.I) CALL LIB$STOP(%VAL(I))
C
	TYPE	210,TIMBUF(1:TIMLEN)
210	FORMAT (/,' Process Timer Request at ',A)
C
	CALL PRINT_PROCESS(STORAGE(ENTRY+3))
C
	TYPE	230,WD_STORAGE(2*ENTRY)
230	FORMAT (' 	Event Flag number 	',I4)
C
	IF (STORAGE(ENTRY+4) .NE. 0) THEN
		TYPE	240,STORAGE(ENTRY+4)
240		FORMAT (' 	AST Address 		',Z8)
		TYPE	250,STORAGE(ENTRY+5)
250		FORMAT (' 	AST Parameter 		',Z8)
	ELSE
		TYPE	260
260		FORMAT (' 	No AST specified')
	ENDIF
C
299	CONTINUE
	ELSE
C
C Print to SYS$OUTPUT from a SCHDWK entry - skip if less than current time
C
	IF (WD_STORAGE(2*ENTRY-1) .NE. 2) CALL LIB$STOP(%VAL(SS$_ACCVIO))
C
	I = SYS$GETTIM(CURRENT_TIME)
		IF(.NOT.I) CALL LIB$STOP(%VAL(I))
		IF ((CURRENT_TIME(1) .EQ. STORAGE(ENTRY+1))  .AND.
	1	    (CURRENT_TIME(2) .EQ. STORAGE(ENTRY+2))) GOTO 399
C
	I = SYS$ASCTIM(TIMLEN,TIMBUF,STORAGE(ENTRY+1),)
		IF(.NOT.I) CALL LIB$STOP(%VAL(I))
C
	TYPE	310,TIMBUF(1:TIMLEN)
310	FORMAT (/,' Scheduled Wakeup Request at  ',A)
C
	CALL PRINT_PROCESS(STORAGE(ENTRY+3))
C
	IF (STORAGE(ENTRY+4) .NE. 0) THEN
		I = SYS$ASCTIM(TIMLEN,TIMBUF,STORAGE(ENTRY+4),%VAL(1))
			IF(.NOT.I) CALL LIB$STOP(%VAL(I))
		TYPE	330,TIMBUF(1:TIMLEN)
330		FORMAT (' 	Repeat every 		',A)
	ELSE
		TYPE	340
340		FORMAT (' 	No scheduled repeats')
	ENDIF
399	CONTINUE
	ENDIF
C
C Move on to the next entry
C
	ENTRY = ENTRY + 6
C
	END DO
C
C The entries have been printed, type end message
C
	TYPE	400,ENTRY/6
400	FORMAT (//,I6, ' entries processed',/)
	IF (KRNL_RET .EQ. '77'X) TYPE 410
410	FORMAT (/,' The storage capacity of TIMER was exceeded.',/)
	END
C
C 
C
C
C Subroutine to print process name and PID to SYS$OUTPUT
C
	SUBROUTINE PRINT_PROCESS(PID)
C
	IMPLICIT INTEGER (S)
C
	BYTE		NAME_ARRAY(15)
	INTEGER*2	FIRST_SLOT(2)
	INTEGER*4	PID,PROC_NAME_LEN,ITMLST(4)
	CHARACTER	PROC_NAME*15
C
	EQUIVALENCE	(FIRST_SLOT,ITMLST)
	EQUIVALENCE	(PROC_NAME,NAME_ARRAY)
C
	INCLUDE		'($JPIDEF)'
C
C Initialize the item list for $GETJPI
C
	FIRST_SLOT(1)	=  15			!Buffer length
	FIRST_SLOT(2)	=  JPI$_PRCNAM		!Item code - process name
	ITMLST(2)	=  %LOC(NAME_ARRAY)	!Address of buffer
	ITMLST(3)	=  %LOC(PROC_NAME_LEN)	!Address of return length
C
	I = SYS$GETJPI (%VAL(1),PID,,ITMLST,,,)
		IF(.NOT.I) CALL LIB$STOP(%VAL(I))
C
	TYPE	10,PROC_NAME(1:PROC_NAME_LEN),PID
10	FORMAT (' 	for Process Name 	',A,/,
	1 ' 	Process ID 		',Z8)
C
	RETURN
	END
