	LOGICAL FUNCTION GET_VAXFILE(FILE)
C
C	This function is used to get the file name of the file
C	on the VAX and then open it for either read or write.
C
C	Inputs:
C		FILE - string descriptor with the file name (if any).
C
	INCLUDE 'COM.INC/NOLIST'

	CHARACTER*(*) FILE, VAXQ

	PARAMETER (VAXQ = 'Enter the name of the VAX file: ')

	GET_VAXFILE = .FALSE.		! Initialize to bad return.
	ASSIGN 100 TO VAX_PROMPT
	ASSIGN 200 TO OPEN_FILE
C
C	If we were passed a file name, use it.
C
	IF (LEN(FILE) .GT. 0) THEN
		VAX_FILE = FILE		! Copy the file name.
		VSIZE = LEN(FILE)	!  and the file size.
		GO TO OPEN_FILE		! Go try to open it.
	ENDIF
C
C	Get the name of the file on the VAX.
C
100	CALL PROMPT_USER(VAXQ,%REF(VAX_FILE),LEN(VAX_FILE))
	IF (BACKUP .OR. LIOSB(1) .NE. SS$_NORMAL) THEN
	    IF (.NOT. DUMP_MODE) CALL SEND_CAN ! Tell remote to abort.
	    RETURN
	ENDIF
	IF (WANTS_HELP) THEN
		IF (FLOW .EQ. IN) THEN
			CALL GET_HELP('GET VAX')
		ELSE
			CALL GET_HELP('SEND VAX')
		ENDIF
		GO TO VAX_PROMPT
	ENDIF
	VSIZE = LBYTE_COUNT			! Copy the byte count.
	IF (VSIZE .EQ. 0) THEN
		IF (RSIZE .GT. 0) THEN
			VAX_FILE = REMOTE_FILE	! Copy the file name,
			VSIZE = RSIZE		!  and the length.
		ELSE
			GO TO VAX_PROMPT	! Try again.
		ENDIF
	ENDIF

200	IF (FLOW .EQ. IN) THEN
		OPEN (UNIT=FILE_UNIT, TYPE='NEW', NAME=VAX_FILE(1:VSIZE),
	1		CARRIAGECONTROL='LIST', BUFFERCOUNT=2, ERR=9900)
	ELSE
		OPEN (UNIT=FILE_UNIT, TYPE='OLD', READONLY,
	1		FILE=VAX_FILE(1:VSIZE), ERR=9900)
	ENDIF
	GET_VAXFILE = .TRUE.		! Return success.
	RETURN
C
C	Here to report open error.
C
C	CALL ERRSNS(num,rmssts,rmsstv,iunit,)
C
C	Where:	num = fortran error code,
C		rmssts = RMS completion status code.
C		rmsstv = RMS status code.
C		iunit = logical unit number.
C
9900	CALL ERRSNS(FERR,RMSSTS,RMSSTV,LUN,)
	CALL CHECK_STATUS('GET_VAXFILE',RMSSTS)
	GO TO VAX_PROMPT		! Go for file name again.
	END

	LOGICAL FUNCTION GET_REMFILE(FILE)
C
C	This function is used to get/open the file name on the remote.
C
	INCLUDE 'COM.INC/NOLIST'

	LOGICAL*1 CODE(1)

	CHARACTER*(*) REMOTEQ, INPUT_ERROR, OUTPUT_ERROR, FILE

	PARAMETER (REMOTEQ = 'Enter the name of the REMOTE file: ')
	PARAMETER (INPUT_ERROR = SS//
	1 '*** Unable to open remote input file ***'//BELL//SS)
	PARAMETER (OUTPUT_ERROR = SS//
	1 '*** Unable to open remote output file ***'//BELL//SS)

	GET_REMFILE = .FALSE.		! Initialize to bad return.
	ASSIGN 100 TO REMOTE_PROMPT
	ASSIGN 200 TO OPEN_FILE
C
C	If we were passed a file name, use it.
C
	IF (LEN(FILE) .GT. 0) THEN
		REMOTE_FILE = FILE	! Copy the file name.
		RSIZE = LEN(FILE)	!  and the file size.
		GO TO OPEN_FILE		! Go try to open it.
	ENDIF
C
C	Get name of file on VAX.
C
100	CALL PROMPT_USER(REMOTEQ,%REF(REMOTE_FILE),LEN(REMOTE_FILE))
	IF (BACKUP .OR. LIOSB(1) .NE. SS$_NORMAL) THEN
		CALL SEND_CAN		! Tell remote to exit.
		RETURN
	ENDIF
	IF (WANTS_HELP) THEN
		IF (FLOW .EQ. IN) THEN
			CALL GET_HELP('GET REMOTE')
		ELSE
			CALL GET_HELP('SEND REMOTE')
		ENDIF
		GO TO REMOTE_PROMPT
	ENDIF
	RSIZE = LBYTE_COUNT			! Copy the byte count.
	IF (RSIZE .EQ. 0) THEN
		IF (VSIZE .GT. 0) THEN
			REMOTE_FILE = VAX_FILE	! Copy the file name,
			RSIZE = VSIZE		!  and the length.
		ELSE
			GO TO REMOTE_PROMPT	! Try again.
		ENDIF
	ENDIF
C
C	Send the file name to the remote.
C
200	CALL WRITE_REMOTE(%REF(REMOTE_FILE),RSIZE)
	CALL GET_RESPONSE(CODE)		! Get response from remote.
	IF (CODE(1) .EQ. CAN) RETURN	! Cancel transmission.
	IF (CODE(1) .EQ. ACK) THEN
		GET_REMFILE = .TRUE.
		RETURN
	ELSE
		IF (FLOW .EQ. IN) THEN
			CALL WRITE_USER(INPUT_ERROR)
		ELSE
			CALL WRITE_USER(OUTPUT_ERROR)
		ENDIF
		GO TO REMOTE_PROMPT
	ENDIF
	END
