	SUBROUTINE GET_PORT
C
C	This routine is used to request the remote port.
C
	INCLUDE 'COM.INC'

	CHARACTER*(*) PORTQ, BAD_PORT
	CHARACTER*50 LOGICAL_DEVICE

	PARAMETER (PORTQ = 
	1 'Enter the port being used for the remote (TTA4:): ')
	PARAMETER (BAD_PORT =
	1 '*** The REMOTE and LOCAL terminal ports must be different. ***'
	1 //BELL//SS)

	IF (STARTUP) THEN
		IF (GET_SYMBOL('REMOTE_PORT',LOGICAL_DEVICE,LBYTE_COUNT)) THEN
			GO TO 110
		ENDIF
	ENDIF
C
C	Ask for VAXNET remote port.
C
100	EXIT_ON_ERROR = .FALSE.		! Don't exit on errors.
	CALL PROMPT_USER(PORTQ,%REF(LOGICAL_DEVICE),50)
	IF (BACKUP) RETURN
	IF (WANTS_HELP) THEN
		CALL GET_HELP('REMOTE_PORT')
		GO TO 100
	ENDIF
110	IF (LBYTE_COUNT .EQ. 0) THEN
		LOGICAL_DEVICE = 'TTA4:'
		LBYTE_COUNT = 5
	ENDIF
C
C	Assign channel to remote terminal.
C
	IF (NEED_TO_DEAS) CALL DEAL_PORT
	NEED_TO_DEAL = .FALSE.		! Presume not allocated.
	STATUS = SYS$ALLOC(LOGICAL_DEVICE(1:LBYTE_COUNT),
	1			REMOTE_SIZE,REMOTE_DEVICE,)
C
C	Make sure remote device is not the same as local device.
C	A normal compare is not used here because of the header
C	preceeding the translation of SYS$COMMAND.
C
	IF (FIND_SUBSTRING (REMOTE_DEVICE(1:REMOTE_SIZE),
	1		LOCAL_DEVICE(1:LOCAL_SIZE)) .GT. 0) THEN
		CALL WRITE_USER (BAD_PORT) ! Tell user the bad news.
		GO TO 100		! And ask for a new port.
	ENDIF
	IF (STATUS .EQ. SS$_DEVALRALLOC) THEN
		NEED_TO_DEAL = .TRUE.	! Show terminal allocated.
	ELSE
		IF (.NOT. STATUS) THEN
			CALL CHECK_STATUS('VAXNET(ALLOC)',STATUS)
			GO TO 100	! Reask port question.
		ENDIF
	ENDIF
	EXIT_ON_ERROR = .TRUE.		! Exit on further errors.
	STATUS = SYS$ASSIGN(REMOTE_DEVICE(1:REMOTE_SIZE),RCHAN_IN,,)
	STATUS = SYS$ASSIGN(REMOTE_DEVICE(1:REMOTE_SIZE),RCHAN_OUT,,)
	IF (STATUS) THEN
		NEED_TO_DEAS = .TRUE.	! We have a port assigned.
	ELSE
		CALL CHECK_STATUS('VAXNET(ASSIGN)',STATUS)
		GO TO 100
	ENDIF
	RETURN
	END

	SUBROUTINE DEAL_PORT
C
C	This routine is used to deassign and deallocate the remote port.
C	We don't need to reset the terminal characteristics because VMS
C	does that automatically when we deallocate.
C
	INCLUDE 'COM.INC'

	STATUS = SYS$DASSGN(%VAL(RCHAN_IN))
	STATUS = SYS$DASSGN(%VAL(RCHAN_OUT))
	CALL CHECK_STATUS('VAXNET(DASSGN)',STATUS)
	STATUS = SYS$DALLOC(REMOTE_DEVICE(1:REMOTE_SIZE),)
	IF (STATUS .NE. SS$_NOPRIV)
	1	CALL CHECK_STATUS('VAXNET(DALLOC)',STATUS)
	NEED_TO_DEAS = .FALSE.		! No remote port assigned.
	RETURN
	END
