	SUBROUTINE WRITE_REMOTE(BUFFER,NBYTES)
C
C	This subroutine is used to write a buffer to the remote.
C
	INCLUDE 'COM.INC/NOLIST'

	LOGICAL*1 BUFFER(1)

	BYTES = NBYTES + 1		! Adjust the byte count.
	BUFFER(BYTES) = CR		! Append Terminator.
	GO TO 100			! And continue ...
C
C	The next entry is used to write the buffer without appending
C	a carriage return to the end of the message.
C
	ENTRY WRITE_BYTE(BUFFER,NBYTES)
	BYTES = NBYTES			! Copy the byte count.

C100	IF (.NOT. DUMP_MODE) THEN
C		CALL CLEAR_TYPEAHEAD	! Clear remote typeahead.
C	ENDIF

100	STATUS = SYS$QIOW(%VAL(REFN_OUT),%VAL(RCHAN_OUT),
	1		%VAL(IO$_WRITELBLK + IO$M_NOFORMAT),
	1		XIOSB,,,BUFFER,%VAL(BYTES),,,,)
	CALL CHECK_STATUS('WRITE_REMOTE',STATUS)
	RETURN
	END

	INTEGER FUNCTION READ_REMOTE(BUFFER,NBYTES)
C
C	This function is called to read a line from the remote.
C
	INCLUDE 'COM.INC/NOLIST'
	LOGICAL*1 BUFFER(1)

100	IF (CONTROLC_TYPED) RETURN	! Return if aborted.

	STATUS = SYS$QIOW(%VAL(REFN_IN),%VAL(RCHAN_IN),
	1		%VAL(IO$_READLBLK + IO$M_NOECHO + IO$M_TIMED),
	1		RIOSB,,,BUFFER,%VAL(NBYTES),
	1		%VAL(TIMEOUT_COUNT),TERMPTR,,)

	READ_REMOTE = STATUS		! Copy the directive status.
	IF (.NOT. CHECK_STATUS('READ_REMOTE',STATUS)) RETURN
	READ_REMOTE = RIOSB(1)		! Pass back I/O status.
	RBYTE_COUNT = RIOSB(2)		! Save the byte count.
	IF (RIOSB(1) .EQ. SS$_TIMEOUT) THEN ! Timeout ?
		TIMEOUTS = TIMEOUTS + 1	! Yes, count it,
		GO TO 200		!  and continue ...
	ELSEIF (RIOSB(1) .EQ. SS$_PARITY) THEN ! Parity error ?
		PARITY_ERRORS = PARITY_ERRORS + 1 ! Yes, count it,
		GO TO 200		!  and continue ...
	ELSE
		CALL CHECK_STATUS('READ_REMOTE',READ_REMOTE)
	ENDIF
	RETURN
C
C	Here for timeout and hardware errors.
C
200	IF (.NOT. DUMP_MODE) THEN
		BUFFER(1) = 0		! Force bad transmission
		RBYTE_COUNT = 0		!  by clearing buffer & BC.
		CALL CLEAR_TYPEAHEAD	! Clear remote typeahead buffer,
	ENDIF
	RETURN
	END

	SUBROUTINE GET_RESPONSE(CODE)
C
C	This subroutine gets a response from the host, makes
C	sure it is valid, then passes the code back for the
C	subroutine to do further processing.
C
C	Action taken:
C	o  if code is ACK, NAK, ENQ, CAN, EOF, or EOT, return code.
C	o  else presume the response was garbled, send ENQ to the
C	   host, and loop to get retransmitted code.
C
	INCLUDE 'COM.INC/NOLIST'
	LOGICAL*1 CODE(1)
	CHARACTER*(*) RETRY_MSG
	PARAMETER (RETRY_MSG = SS//
	1 '*** Retry limit of 8 exceeded, aborting transmission. ***'
	1 //BELL//SS)

	RETRY_COUNT = 0			! Initialize retry counter.
100	IF (CONTROLC_TYPED) RETURN	! Return if aborted.
	IF (READ_REMOTE(RBUFFER,READ_SIZE) .EQ. SS$_ABORT) RETURN
	CODE(1) = RBUFFER(1)		! Copy the received code.
	IF (CODE(1) .EQ. ACK .OR. CODE(1) .EQ. NAK) GO TO 200
	IF (CODE(1) .EQ. ENQ .OR. CODE(1) .EQ. CAN) GO TO 200
	IF (CODE(1) .EQ. EOF .OR. CODE(1) .EQ. EOT) GO TO 200
	RETRY_COUNT = RETRY_COUNT + 1	! Increment retry count.
	IF (RETRY_COUNT .GT. RETRY_LIMIT) THEN
		CALL WRITE_USER(RETRY_MSG)
		CODE(1) = CAN		! Cancel transmission,
		RETURN			!  and return.
	ELSE
		IF (DEBUG_MODE) CALL WRITE_BUFFER(RBUFFER,RBYTE_COUNT)
		CALL SEND_ENQ		! Send remote an ENQ,
		GO TO 100		!  and try again.
	ENDIF
C
C	Here for valid code.
C
200	IF (RBYTE_COUNT .GT. 1)
	1	CALL WRITE_BUFFER(RBUFFER(2),RBYTE_COUNT-1)
	RETURN
	END

	SUBROUTINE WRITE_BUFFER(BUFFER,NBYTES)
C
C	This subroutine writes the contents of the buffer received
C	from the remote to the terminal and the log file.
C
	INCLUDE 'COM.INC/NOLIST'
	LOGICAL*1 BUFFER(1)

	IF (DEBUG_MODE) THEN
		TYPE 100, NBYTES, SS
		CALL FLUSH_LOGFILE
		IF (LOGFILE) WRITE (LOG_UNIT,100) NBYTES, DS
100		FORMAT (' The buffer received from the remote contains (',
	1		I4,'):',A)
	ENDIF
	IF (NBYTES .EQ. 0) RETURN
C
C	Write the buffer to the terminal and the logfile.
C
	CALL WRITE_LOGFILE(BUFFER,NBYTES)
	IF (BATCH_MODE) THEN
		WRITE (OUT_UNIT,200) (BUFFER(I),I=1,NBYTES)
200		FORMAT(<NBYTES>A1)
	ELSE
		LOCAL_STATUS = SYS$QIOW(%VAL(LEFN_OUT),%VAL(LCHAN_IN),
	1		%VAL(IO$_WRITELBLK + IO$M_NOFORMAT),
	1		LIOSB,,,BUFFER,%VAL(NBYTES),,,,)
	ENDIF
	IF (DEBUG_MODE) CALL WRITE_USER(DS)
	RETURN
	END
