C
C	Utility routines for VAXNET.
C
	INTEGER FUNCTION CHECK_TYPEAHEAD
C
C	This routine checks for characters in the remote typeahead
C	buffer.  It passes back the typeahead count (if any).
C
	INCLUDE 'COM.INC/NOLIST'

	STATUS = SYS$QIOW(%VAL(REFN_IN),%VAL(RCHAN_IN),
	1	%VAL(IO$_SENSEMODE + IO$M_TYPEAHDCNT),
	1	RIOSB,,,TYPEAHEAD_COUNT,,,,,)

	CALL CHECK_STATUS('CHECK_TYPEAHEAD',STATUS)
	CHECK_TYPEAHEAD = TYPEAHEAD_COUNT(1)	! Pass back the count.
	RETURN
	END

	SUBROUTINE CLEAR_TYPEAHEAD
C
C	Clears the typeahead buffer on the remote channel.
C
	INCLUDE 'COM.INC/NOLIST'

	STATUS = SYS$QIOW(%VAL(REFN_IN),%VAL(RCHAN_IN),
	1	%VAL(IO$_READLBLK + IO$M_PURGE),
	2	RIOSB,,,RBUFFER,%VAL(0),,,,)
	CALL CHECK_STATUS('CLEAR_TYPEAHEAD',STATUS)
	RETURN
	END

	SUBROUTINE TOTALS(NBYTES)
C
C	Accumulate the totals.
C
	INCLUDE 'COM.INC/NOLIST'
	INCLUDE 'TTDEF.FOR/NOLIST'

	BYTE_COUNT = BYTE_COUNT + NBYTES	! Accumulate byte count.
	RECORD_COUNT = RECORD_COUNT + 1		! Accumulate record count.
	TOTAL_BYTES = TOTAL_BYTES + NBYTES	! Total byte count.
	TOTAL_RECORDS = TOTAL_RECORDS + 1	! Total record count.

100	IF ((LOCAL_CHAR(2) .AND. TT$M_SCOPE) .NE. 0) THEN
		TYPE 150, RECORD_COUNT, BYTE_COUNT, ERROR_COUNT, ERROR_RECORD
	ENDIF
150	FORMAT('+Record count:', I6,', byte count:', I8,
	1	', Naks:', I5, ' (', I6, ')')
	RETURN
C
C	Entry to initialize counts.
C
	ENTRY CLEAR_COUNTS
	BYTE_COUNT = 0			! Clear byte count.
	RECORD_COUNT = 0		! Clear record count.
	TOTAL_BYTES = 0			! Clear total bytes.
	TOTAL_RECORDS = 0		! Clear total records.
	ERROR_COUNT = 0			! Clear error count.
	ERROR_RECORD = 0		! Clear error record #.
	RETURN
C
C	Entry to report a transmission error.
C
	ENTRY REPORT_ERROR
	ERROR_COUNT = ERROR_COUNT + 1
	ERROR_RECORD = RECORD_COUNT + 1
	CALL FLUSH_LOGFILE		! Empty the logfile.
	IF (LOGFILE) WRITE (LOG_UNIT,200) RECORD_COUNT+1, SS
200	FORMAT (X,'Transmission ERROR on RECORD ', I6, A)
	GO TO 100			! Update terminal.
C
C	Entry to print final message.
C
	ENTRY PRTFINAL
	CALL FLUSH_LOGFILE		! Empty the logfile.
	IF (LOGFILE) THEN
	    WRITE (LOG_UNIT,300) RECORD_COUNT, BYTE_COUNT, SS
300	    FORMAT ('Total records:', I6,', total bytes:', I8, A)
	ENDIF
	RETURN
	END

	INTEGER FUNCTION GET_CHECKSUM(BUFFER,NBYTES)
C
C	Computes the checksum.
C
	LOGICAL*1 BUFFER(1)

	GET_CHECKSUM = 0		! Initialize checksum.
	IF (NBYTES .GT. 0) THEN
		DO 100 I=1,NBYTES
		GET_CHECKSUM = GET_CHECKSUM + BUFFER(I)
100		CONTINUE
	ENDIF
	GET_CHECKSUM = GET_CHECKSUM .AND. "777
	RETURN
	END

	SUBROUTINE SEND_CODE
C
C	These routines are used to send a control character to the remote.
C
C	The entrys for sending of SOH, STX, and ETX were added for the
C	DEC DF03 ACU.  They must not have a carriage return appended to
C	them as do the other control characters.
C
	INCLUDE 'COM.INC/NOLIST'
	LOGICAL*1 LAST_CODE(2)
C
C	Entry to send SOH (Start of Header).	CTRL/A
C
	ENTRY SEND_SOH
	LAST_CODE(1) = SOH		! Save the last code.
	GO TO 50			!  and send it.
C
C	Entry to send STX (Start of Text).	CTRL/B
C
	ENTRY SEND_STX
	LAST_CODE(1) = STX		! Save the last code.
	GO TO 50			!  and send it.
C
C	Entry to send ETX (End of Text).	CTRL/C
C
	ENTRY SEND_ETX
	LAST_CODE(1) = ETX		! Save the last code.
50	CALL WRITE_BYTE(LAST_CODE(1),1)	! Write a single byte.
	RETURN
C
C	Entry to send ACK (Acknowlegment).
C
	ENTRY SEND_ACK
	LAST_CODE(1) = ACK		! Save the last code.
	GO TO 100			!  and send it.
C
C	Entry to send NAK (Negative Acknowlement).
C
	ENTRY SEND_NAK
	LAST_CODE(1) = NAK		! Save the last code,
	GO TO 100			!  and send it.
C
C	Entry to send SYN (Synchronize).
C
	ENTRY SEND_SYN
	LAST_CODE(1) = SYN		! Save the last code,
	GO TO 100 			!  and send it.
C
C	Entry to send ENQ (Enquire).
C
	ENTRY SEND_ENQ
	LAST_CODE(1) = ENQ		! Save the last code,
	GO TO 100			!  and send it.
C
C	Entry to send EOF (End of File).
C
	ENTRY SEND_EOF
	LAST_CODE(1) = EOF 		! Save the last code,
	GO TO 100			!  and send it.
C
C	Entry to send EOT (End of Transmission).
C
	ENTRY SEND_EOT
	LAST_CODE(1) = EOT		! Save the last code,
	GO TO 100			!  and send it.
C
C	Entry to send CAN (Cancel).
C
	ENTRY SEND_CAN
	LAST_CODE(1) = CAN		! Save the last code,
	GO TO 100			!  and send it.
C
C	This entry is used to resend the last code in the event that
C	the previous transmission was lost or garbled and the remote
C	sent us an ENQ to find out what the last response was.
C
	ENTRY RESEND_CODE
100	CALL WRITE_REMOTE(LAST_CODE(1),1)
	RETURN
	END

	SUBROUTINE WAITABIT(SECONDS)
C
C	This subroutine just waits a little then returns.
C
	IMPLICIT INTEGER*4 (A-Z)

	CHARACTER*(*) SECONDS
	INTEGER*4 DELTA(2)

	STATUS = SYS$BINTIM('0 00:00:'//SECONDS,DELTA)
	IF (.NOT. CHECK_STATUS('WAITABIT(BINTIM)',STATUS)) RETURN
	STATUS = SYS$SCHDWK(,,DELTA,,)	! Schedule wakeup.
	IF (.NOT. CHECK_STATUS('WAITABIT(SCHDWK)',STATUS)) RETURN
	STATUS = SYS$HIBER()		! Go into hibernation.
	RETURN
	END

	SUBROUTINE SET_TERMINATOR(PTR,TBL,TBYTE)
C
C	This routine is used to set the terminator character for reads
C	in the terminator table.  This table which has 256 bits for
C	this entire character set, must have a bit set for each character
C	used to terminate a read (i.e., <CR>).  Currently, I presume
C	only one character is used to terminate the read (table is cleared).
C
C	Inputs:
C		PTR - address of table pointer.
C		TBL - address of terminator table.
C		TBYTE - byte to set into table.
C
	IMPLICIT INTEGER*4 (A-Z)

	INTEGER*4 PTR(2), TBL(8)
	LOGICAL*1 TBYTE(1)

	DO 100 I=1,8
	TBL(I) = 0			! Clear the entire table.
100	CONTINUE
	I = ((TBYTE(1)/32) + 1)		! Offset into table.
	BIT = (TBYTE(1) - ((I-1)*32)) 	! Bit to set in longword.
	PTR(1) = I*4			! Terminator table size.
	PTR(2) = %LOC(TBL)		! Fill in the table address.
	CALL LIB$INSV(1,BIT,1,TBL(I))	! Set the terminator bit.
	RETURN
	END

	INTEGER FUNCTION FIND_SUBSTRING (SUB,S)
C
C	This routine is used to search for a substring in a string.
C
C	Inputs:
C		SUB and S are character string descriptors.
C
C	Outputs:
C		Returns position of substring or 0 if not found.
C
	CHARACTER*(*) SUB, S

	FIND_SUBSTRING = INDEX (S, SUB)	! Pass back the status.
	RETURN
	END	

	LOGICAL FUNCTION CVT_DTB(STR,NUM)
C
C	This routine is used to convert an ASCII string of numbers to
C	an integer.
C
C	Inputs:
C		STR - string descriptor.
C		NUM - integer to return number to.
C
C	Outputs:
C		.TRUE./.FALSE. = success/failure.
C
	CHARACTER*(*) STR
	INTEGER*4 NUM

	CVT_DTB = LIB$CVT_DTB(%VAL(LEN(STR)),%REF(STR),NUM)
	RETURN
	END

	SUBROUTINE CVT_CTRL(BUFF,SIZE)
C
C	This routine searches for and converts "^char" to control
C	characters.  The original buffer is converted (if necessary)
C	and the new buffer size is passed back in SIZE.
C
	LOGICAL*1 BUFF(1)
	INTEGER*4 SIZE

	I = 1				! Input buffer index.
	O = 1				! Output buffer index.
100	IF (I .GT. SIZE) THEN		! If finished,
		BUFF(O) = 0		! Terminate the buffer.
		SIZE = O - 1		! And pass back new size.
		RETURN
	ENDIF
	BUFF(O) = BUFF(I)		! Copy the next character.
	IF (BUFF(O) .EQ. '^') THEN	! If its an "^",
		I = I + 1		! Point to the next
		BUFF(O) = BUFF(I)-64	! and convert to ctrl/char.
	ENDIF
	I = I + 1			! Next input index.
	O = O + 1			! Next output index.
	GO TO 100			! Loop until we're done.
	END

	INTEGER FUNCTION GET_EFN(EVENT_FLAG)
C
C	Get an event flag.
C
	IMPLICIT NONE
	INTEGER*4 EVENT_FLAG, CHECK_STATUS, LIB$GET_EF, STATUS

	STATUS = LIB$GET_EF(EVENT_FLAG)	! Local input event flag.
	CALL CHECK_STATUS('LIB$GET_EF',STATUS)
	RETURN
	END
