$ VFL='F$VERIFY(0)
$!	SET DEFAULT DIRECTORIES		Tom Kent/Rick Bryan. June, 1979
$!
$!	modified to accept all logicals (without colon),
$!		rooted directories and several other
$!		horrors of VMS 3.0.
$!			G H Cohen  13-Oct-1982
$!	modified to accept explicit disk requests
$!				- vicki 13-aug-1979
$!	Modified 9/7/79 by Stan Knutson
$!		SD <n 	for any n
$!		SD ? p 	for help parameters
$!		check for existence of directory if default changed
$!		New help file.
$!		SD . resets disk as well as directory
$!	modified 16sep79 to change error message produced by default
$!		when check for existence is made..
$!		if the test fails .. then the current entry is popped from
$!		the stack
$!
$!	Command file for showing/changing default directories.
$!	Do "SD ?" for help.
$!	Fixed, reorganized and largely rewritten by Richard L. Bryan, MIT/LCS
$!
$! Equivalences for code clarity
$	GOSUB  := GOTO
$	RETURN := GOTO &RETURN_TAG
$!
$! Initialization
$	DEFDIRECT:=  'F$DIRECTORY()
$	DISK	 :=  "SYS$DISK"
$	DEFDSK   :=  'F$LOGICAL(DISK)
$	STACK_SIZE=  8-1	!must be 2**N-1
$	SD_SP    ==  "''SD_SP'"	  ! BE SURE SD_SP IS DEFINED
$	IF F$LENGTH(SD_SP).GT.0 THEN GOTO 5$
$	  RETURN_TAG := 5$
$	  GOSUB INIT_STACK
$5$:
$!
$! Check for the special cases
$	IF P1 .EQS. ""   THEN GOTO DONE
$	IF P1 .EQS. "."  THEN GOTO POINT
$	IF P1 .EQS. "^"  THEN GOTO UP_ONE
$	IF P1 .EQS. "^^" THEN GOTO UP_TOP
$	IF P1 .EQS. "*"  THEN GOTO STAR
$	IF 'F$LOCATE(">",P1) .EQ. 0 THEN GOTO ACROSS
$	IF P1 .EQS. "<<" THEN GOTO STACK_LIST
$	IF 'F$LOCATE("<",P1) .EQ. 0 THEN GOTO POP
$	IF P1 .EQS. "?"  THEN GOTO HELP
$!
$! Check for device included, and translate it if possible
$	P1 = P1 + P2
$	P1LEN = F$LENGTH(P1)
$	SD_X = F$LOCATE(":",P1)
$	DISK = F$EXTRACT(0,SD_X,P1)
$	DISKT = F$LOGICAL(DISK)
$	IF DISKT.EQS."" .AND. P1LEN.EQ.SD_X -
		THEN GOTO DO_BRACKETS
$	SET DEFAULT 'DISK':
$	IF SD_X.GE.F$LENGTH(P1)-1 THEN GOTO PUSH
$	SD_X = SD_X + 1
$	P1   := 'F$EXTRACT(SD_X,255,P1)
$DO_BRACKETS:
$!
$!  Strip off the superfluous [] or <>
$	P1 = P1 - "[" - "]" - "<" - ">"
$!
$! If starting with ".", we're chaining down from the current level
$	IF 'F$LOCATE(".",P1) .EQ. 0 THEN GOTO DOWN
$!
$! Well, looks like all need to do is to change the directory to a new one.
$!
$	SET DEF ['P1']
$	GOTO PUSH
$!
$!-------------------------------------------------------
$ACROSS:
$!
$! Go to a new subdirectory at this level.
$!
$	P1 := 'F$EXTRACT(1,255,P1)	!remove initial ">"
$	IF 'F$LENGTH(P1) .EQ. 0 THEN GOTO DONE	!catch just ">"
$	RETURN_TAG := 30$
$	GOSUB REMOVE_LAST_SUB
$30$:
$	SET DEFAULT 'SUB'.'P1']
$	GOTO PUSH
$!-------------------------------------------------------
$UP_TOP:
$!
$! Go to top level of this directory.
$!
$	POS = 'F$LOCATE(".",DEFDIRECT)
$	IF POS .EQ. 'F$LENGTH(DEFDIRECT) THEN GOTO DONE
$! If no "." then the use is already at the top; do nothing. Otherwise,
$! extract the toplevel directory from the current directory string.
$	SUB := 'F$EXTRACT(0,POS,DEFDIRECT)
$	SET DEFAULT 'SUB']	!restoring the "]" removed by the extract
$	GOTO PUSH
$!-------------------------------------------------------
$UP_ONE:
$!
$! Go up one level from the current subdirectory.
$!
$	RETURN_TAG := 40$
$	GOSUB REMOVE_LAST_SUB
$40$:
$	SET DEFAULT 'SUB']
$	GOTO PUSH
$!-------------------------------------------------------
$REMOVE_LAST_SUB:
$!  Find position of last "." in DEFDIRECT
$	SUB := 'DEFDIRECT
$	FOUND = 0				  !false
$50$:
$	SD_X = 'F$LOCATE(".",SUB)		  !find the next "."
$	IF SD_X .EQ. 'F$LENGTH(SUB) THEN GOTO 60$ !if none, exit loop
$	  SD_X = SD_X+1				  !skip the "."
$	  SD_L = F$LENGTH(SUB) - SD_X		  !remaining length
$	  SUB  = F$EXTRACT(SD_X,SD_L,SUB)	  !flush "." and stuff before
$	  FOUND = 1				  !true
$	  GOTO 50$				  !next time
$60$:
$	SD_X = 'F$LENGTH(DEFDIRECT) - 1
$	IF FOUND THEN SD_X = SD_X - 'F$LENGTH(SUB)
$	SUB := 'F$EXTRACT(0,SD_X,DEFDIRECT)
$	RETURN
$!-------------------------------------------------------
$POINT:
$!
$!	Restore user's default directory, as stored in
$!	symbol DEFDIR, defined at login time.
$!
$	SET DEF 'DEFDISK''DEFDIR
$	GOTO PUSH
$!-------------------------------------------------------
$DOWN:
$! Chain down from the present level to the new one.
$! E.g. "SD .L1.L2"
$!
$	SD_X = 'F$LENGTH(DEFDIRECT) -1
$	SUB := 'F$EXTRACT(0,SD_X,DEFDIRECT)
$	SET DEF 'SUB''P1']
$	GOTO PUSH
$!-------------------------------------------------------
$POP:
$! Pop one or more levels of the default-name stack "into" the default
$!
$	SD_X = 1			!Assume just 1 level
$	IF P2 .eqs. "" 		THEN GOTO 84$
$	IF P2 .GT. 1 		THEN SD_X = P2 .AND. STACK_SIZE
$	GOTO 88$
$84$:
$	SD_SUB = F$EXTRACT (1,10,P1)
$	IF SD_SUB.EQS."" 	THEN GOTO 88$
$	SD_X = F$INTEGER(SD_SUB)
$88$:
$	SD_SP == (SD_SP - SD_X) .AND. STACK_SIZE
$	SET DEFAULT &SD_SLOT'SD_SP
$	GOTO DONE
$!-------------------------------------------------------
$INIT_STACK:
$! Initialize default-name stack pointer and slots.
$! Do this by setting all slots to the initial (login) default.
$	SD_SP == 0
$80$:
$	SD_SLOT'SD_SP :== 'DEFDIR
$	SD_SP == SD_SP + 1
$	IF SD_SP .LT. 8 THEN GOTO 80$
$	SD_SP == 0
$	RETURN
$!-------------------------------------------------------
$STACK_LIST:
$! List the default-name stack
$	WRITE SYS$OUTPUT "Default spec stack:"
$	SP = SD_SP
$90$:
$	WRITE SYS$OUTPUT "  ",SD_SLOT'SP
$	SP = (SP-1) .AND. STACK_SIZE
$	IF SP .NE. SD_SP THEN GOTO 90$
$	WRITE SYS$OUTPUT "Current default:"
$	GOTO DONE
$!-------------------------------------------------------
$STAR:
$!
$! List all subdirectories under the current one.
$! Invoke the subdirectory command, SUB.TEC
$!
$ MCR TECO @sys$system:SUB
$ GOTO END
$!-------------------------------------------------------
$HELP:
$	WRITE SYS$OUTPUT "$ HELP SD ''P2 ''P3"
$	HELP SD 'P2 'P3
$	GOTO END
$!-------------------------------------------------------
$PUSH:
$! Push the current default onto the 8-level default-name stack
$	SD_SP == (1+SD_SP) .AND. STACK_SIZE
$	SD_SLOT'SD_SP :== 'F$LOG("SYS$DISK")''F$DIRECTORY()
$!
$! Is this a directory device?
$!
$	if f$getdvi("sys$disk","dir").eq."false" then goto invalid
$!
$! Check to see if the directory really exists.
$!
$	IF F$GETDVI("SYS$DISK","EXISTS").EQS."FALSE" THEN GOTO INVALID
$	TMP := "''F$DIRECTORY()'"
$	ADIR := 'F$PARSE(TMP)
$	IF ADIR.EQS."" THEN GOTO INVALID
$	GOTO CONTINUE		! It's ok
$!
$ invalid:
$!
$!	Error only if no directory found.
$	WRITE SYS$OUTPUT "INVALID DIRECTORY"
$	P2 = 1
$	GOTO POP
$!
$ CONTINUE:
$! If there's a SDENTRY.COM file, do it
$	IF F$SEARCH("SDENTRY.COM").EQS."" THEN GOTO DONE
$	  @SDENTRY
$! Fall thru
$!
$DONE:
$!	Now show the default so that the user knows where he ended up.
$!	Also, if there was just a null argument, the user is just asking
$!	for the default.
$!
$	SHOW DEFAULT
$END:
$	IF VFL.EQ.1 THEN SET VERIFY
