      Program SyncChkS
!
!     Check synchronization of system times between VAXes.  SLAVE process.
!
!     Written by:  Mark Paulk
!     System Development Corporation
!     22 September 1983
!

      include 'syncchk.cmn'

      character*4 this_node, shmem
      integer input_addr(2), output_addr(2)


!     Find out which shared memory contains the data base.

      status = lib$get_foreign (shmem)
      if (.not. status) call lib$stop(%val(status))

!     Define flag characteristics for the global section as Global,
!     Permanent, and Writeable.

      flags = SEC$M_WRT

!     Open the disk file for global section creation and mapping by calling
!     the bliss routine OPENSEC.
!     Define the input addresses.
!     Create and map a global section in shared memory.
!     Initialize the data in the shared memory - system time and NICR.

      input_addr(1) = %loc(buffer(1))
      input_addr(2) = %loc(buffer(byte_size))
      status = sys$mgblsc (input_addr, output_addr, , %val(flags),
     &shmem//':SYNCHECK', , )
      write (6,70) shmem, input_addr, output_addr
 70   format (1x,a,' - Specified:', 2z8,
     &' Obtained:', 2z8)
      if(.not. status) call lib$stop(%val(status))

!     Call kernel mode routine to check synchronization.

      call sys$gettim (remote_time_start)
      call sync_check_slave (time, n_checks/2)
      call sys$gettim (remote_time_end)

!     Cleanup.

      status = sys$dgblsc(,shmem//':SYNCHECK',)

      end
